/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1;

import com.oss.asn1.*;
import com.oss.metadata.*;

public class Libitscam_asn1 extends ASN1Project {

    /**
     * Initialize the pdu decoder.
     */
    private static final ProjectInfo c_projectInfo = new ProjectInfo (
	null,
	new byte[] {
	    (byte)0x0b, (byte)0xee, (byte)0x86, (byte)0x4c, (byte)0xc8,
	    (byte)0xa5, (byte)0x00, (byte)0x7b, (byte)0xab, (byte)0xa4,
	    (byte)0x00, (byte)0x7b, (byte)0xab, (byte)0xb0, (byte)0xc6,
	    (byte)0x32, (byte)0x08, (byte)0x27, (byte)0xed, (byte)0x71,
	    (byte)0x90, (byte)0x8d, (byte)0xf3, (byte)0xb8, (byte)0x5d,
	    (byte)0x5e, (byte)0x15, (byte)0xf4, (byte)0xa4, (byte)0x1d,
	    (byte)0xbd, (byte)0x33, (byte)0xfc, (byte)0x75, (byte)0x48,
	    (byte)0x7e, (byte)0x1f, (byte)0x1e, (byte)0xb0, (byte)0x5f,
	    (byte)0x81, (byte)0x68, (byte)0xde, (byte)0xd9, (byte)0xc1,
	    (byte)0xe7, (byte)0xeb, (byte)0x93, (byte)0x75, (byte)0xa8,
	    (byte)0xa0, (byte)0xea, (byte)0xca, (byte)0xf1, (byte)0x0d,
	    (byte)0xc3, (byte)0x9c, (byte)0x7c, (byte)0x59, (byte)0xac,
	    (byte)0xe7, (byte)0x49, (byte)0x2e, (byte)0xdf, (byte)0xe0,
	    (byte)0x56, (byte)0x8f, (byte)0x4f, (byte)0x11, (byte)0xc5,
	    (byte)0xf3, (byte)0x9c, (byte)0x00, (byte)0xac, (byte)0x26,
	    (byte)0xe5, (byte)0x38, (byte)0x48, (byte)0x22, (byte)0x65,
	    (byte)0x6e, (byte)0xa4, (byte)0x16, (byte)0x3c, (byte)0x9f,
	    (byte)0x24, (byte)0x9f, (byte)0x3a, (byte)0x5e, (byte)0x79,
	    (byte)0xab, (byte)0x65, (byte)0x4a, (byte)0x01, (byte)0xc1,
	    (byte)0xd8, (byte)0x88, (byte)0xf5, (byte)0xbc, (byte)0x52,
	    (byte)0xea, (byte)0x0a, (byte)0x9e, (byte)0x24, (byte)0x54,
	    (byte)0xc8, (byte)0x2d, (byte)0x05, (byte)0x3a, (byte)0xb7,
	    (byte)0xa1, (byte)0x52, (byte)0x05, (byte)0x9c, (byte)0xd3,
	    (byte)0x68, (byte)0x7c, (byte)0x47, (byte)0x9f, (byte)0xf4,
	    (byte)0x96, (byte)0xdf, (byte)0x8b
	}
    );
    
    /**
     * Get the project descriptor of 'this' object.
     */
    public ProjectInfo getProjectInfo()
    {
	return c_projectInfo;
    }
    
    private static final ASN1Project c_project = new Libitscam_asn1();

    /**
     * Methods for accessing Coders.
     */
    public static Coder getDefaultCoder()
    {
	return createPERAlignedCoder(c_project);
    }
    
    public static PERAlignedCoder getPERAlignedCoder()
    {
	return createPERAlignedCoder(c_project);
    }
    
    public static PERUnalignedCoder getPERUnalignedCoder()
    {
	return createPERUnalignedCoder(c_project);
    }
    
}
