/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type BasicVehicleContainerLowFrequency from ASN1 Module CAM_PDU_Descriptions.
 * @see Sequence
 */

public class BasicVehicleContainerLowFrequency extends Sequence {
    
    /**
     * The default constructor.
     */
    public BasicVehicleContainerLowFrequency()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public BasicVehicleContainerLowFrequency(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleRole vehicleRole, 
		    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ExteriorLights exteriorLights, 
		    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PathHistory pathHistory)
    {
	setVehicleRole(vehicleRole);
	setExteriorLights(exteriorLights);
	setPathHistory(pathHistory);
    }
    
    public void initComponents()
    {
	mComponents[0] = org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleRole._default;
	mComponents[1] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ExteriorLights();
	mComponents[2] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PathHistory();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[3];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleRole._default;
	    case 1:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ExteriorLights();
	    case 2:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PathHistory();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "vehicleRole"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleRole getVehicleRole()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleRole)mComponents[0];
    }
    
    public void setVehicleRole(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleRole vehicleRole)
    {
	mComponents[0] = vehicleRole;
    }
    
    
    // Methods for field "exteriorLights"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ExteriorLights getExteriorLights()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ExteriorLights)mComponents[1];
    }
    
    public void setExteriorLights(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ExteriorLights exteriorLights)
    {
	mComponents[1] = exteriorLights;
    }
    
    
    // Methods for field "pathHistory"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PathHistory getPathHistory()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PathHistory)mComponents[2];
    }
    
    public void setPathHistory(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PathHistory pathHistory)
    {
	mComponents[2] = pathHistory;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
	    "BasicVehicleContainerLowFrequency"
	),
	new QName (
	    "CAM-PDU-Descriptions",
	    "BasicVehicleContainerLowFrequency"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"VehicleRole"
			    ),
			    new QName (
				"ITS-Container",
				"VehicleRole"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"default",
					0
				    ),
				    new MemberListElement (
					"publicTransport",
					1
				    ),
				    new MemberListElement (
					"specialTransport",
					2
				    ),
				    new MemberListElement (
					"dangerousGoods",
					3
				    ),
				    new MemberListElement (
					"roadWork",
					4
				    ),
				    new MemberListElement (
					"rescue",
					5
				    ),
				    new MemberListElement (
					"emergency",
					6
				    ),
				    new MemberListElement (
					"safetyCar",
					7
				    )
				}
			    ),
			    0,
			    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleRole._default
			)
		    ),
		    "vehicleRole",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"ExteriorLights"
			    ),
			    new QName (
				"ITS-Container",
				"ExteriorLights"
			    ),
			    12314,
			    new SizeConstraint (
				new SingleValueConstraint (
				    new com.oss.asn1.INTEGER(8)
				)
			    ),
			    new Bounds (
				new java.lang.Long(8),
				new java.lang.Long(8)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"lowBeamHeadlightsOn",
					0
				    ),
				    new MemberListElement (
					"highBeamHeadlightsOn",
					1
				    ),
				    new MemberListElement (
					"leftTurnSignalOn",
					2
				    ),
				    new MemberListElement (
					"rightTurnSignalOn",
					3
				    ),
				    new MemberListElement (
					"daytimeRunningLightsOn",
					4
				    ),
				    new MemberListElement (
					"reverseLightOn",
					5
				    ),
				    new MemberListElement (
					"fogLightOn",
					6
				    ),
				    new MemberListElement (
					"parkingLightsOn",
					7
				    )
				}
			    )
			)
		    ),
		    "exteriorLights",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ContainerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"PathHistory"
			    ),
			    new QName (
				"ITS-Container",
				"PathHistory"
			    ),
			    12314,
			    new SizeConstraint (
				new ValueRangeConstraint (
				    new AbstractBounds(
					new com.oss.asn1.INTEGER(0), 
					new com.oss.asn1.INTEGER(23),
					0
				    )
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(23)
			    ),
			    new TypeInfoRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "PathPoint"
				)
			    )
			)
		    ),
		    "pathHistory",
		    2,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' BasicVehicleContainerLowFrequency object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' BasicVehicleContainerLowFrequency object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for BasicVehicleContainerLowFrequency
