/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type HighFrequencyContainer from ASN1 Module CAM_PDU_Descriptions.
 * @see Choice
 */

public class HighFrequencyContainer extends Choice {
    
    /**
     * The default constructor.
     */
    public HighFrequencyContainer()
    {
    }
    
    public static final  int  basicVehicleContainerHighFrequency_chosen = 1;
    public static final  int  emptyRSUContainerHighFrequency_chosen = 2;
    
    // Methods for field "basicVehicleContainerHighFrequency"
    public static HighFrequencyContainer createHighFrequencyContainerWithBasicVehicleContainerHighFrequency(BasicVehicleContainerHighFrequency basicVehicleContainerHighFrequency)
    {
	HighFrequencyContainer __object = new HighFrequencyContainer();

	__object.setBasicVehicleContainerHighFrequency(basicVehicleContainerHighFrequency);
	return __object;
    }
    
    public boolean hasBasicVehicleContainerHighFrequency()
    {
	return getChosenFlag() == basicVehicleContainerHighFrequency_chosen;
    }
    
    public void setBasicVehicleContainerHighFrequency(BasicVehicleContainerHighFrequency basicVehicleContainerHighFrequency)
    {
	setChosenValue(basicVehicleContainerHighFrequency);
	setChosenFlag(basicVehicleContainerHighFrequency_chosen);
    }
    
    
    // Methods for field "emptyRSUContainerHighFrequency"
    public static HighFrequencyContainer createHighFrequencyContainerWithEmptyRSUContainerHighFrequency(EmptyRSUContainerHighFrequency emptyRSUContainerHighFrequency)
    {
	HighFrequencyContainer __object = new HighFrequencyContainer();

	__object.setEmptyRSUContainerHighFrequency(emptyRSUContainerHighFrequency);
	return __object;
    }
    
    public boolean hasEmptyRSUContainerHighFrequency()
    {
	return getChosenFlag() == emptyRSUContainerHighFrequency_chosen;
    }
    
    public void setEmptyRSUContainerHighFrequency(EmptyRSUContainerHighFrequency emptyRSUContainerHighFrequency)
    {
	setChosenValue(emptyRSUContainerHighFrequency);
	setChosenFlag(emptyRSUContainerHighFrequency_chosen);
    }
    
    
    // Method to create a specific choice instance
    public AbstractData createInstance(int chosen)
    {
	switch (chosen) {
	    case basicVehicleContainerHighFrequency_chosen:
		return new BasicVehicleContainerHighFrequency();
	    case emptyRSUContainerHighFrequency_chosen:
		return new EmptyRSUContainerHighFrequency();
	    default:
		throw new InternalError("Choice.createInstance()");
	}
	
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final ChoiceInfo c_typeinfo = new ChoiceInfo (
	new Tags (
	    null
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
	    "HighFrequencyContainer"
	),
	new QName (
	    "CAM-PDU-Descriptions",
	    "HighFrequencyContainer"
	),
	12318,
	null,
	new Fields (
	    new FieldInfo[] {
		new FieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				"BasicVehicleContainerHighFrequency"
			    ),
			    new QName (
				"CAM-PDU-Descriptions",
				"BasicVehicleContainerHighFrequency"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				    "BasicVehicleContainerHighFrequency"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				    "BasicVehicleContainerHighFrequency"
				)
			    ),
			    0
			)
		    ),
		    "basicVehicleContainerHighFrequency",
		    0,
		    2
		),
		new FieldInfo (
		    new TypeInfoRef (
			new TypeInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				"EmptyRSUContainerHighFrequency"
			    ),
			    new QName (
				"CAM-PDU-Descriptions",
				"EmptyRSUContainerHighFrequency"
			    ),
			    12314,
			    null
			)
		    ),
		    "emptyRSUContainerHighFrequency",
		    1,
		    2
		)
	    }
	),
	0,
	new TagDecoder (
	    new TagDecoderElement[] {
		new TagDecoderElement((short)0x8000, 0),
		new TagDecoderElement((short)0x8001, 1)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' HighFrequencyContainer object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' HighFrequencyContainer object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Check the current selection on unknown extension
     */
    public final boolean hasUnknownExtension()
    {
	return getChosenFlag() > 2;
    }
    
} // End class definition for HighFrequencyContainer
