/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type LowFrequencyContainer from ASN1 Module CAM_PDU_Descriptions.
 * @see Choice
 */

public class LowFrequencyContainer extends Choice {
    
    /**
     * The default constructor.
     */
    public LowFrequencyContainer()
    {
    }
    
    public static final  int  basicVehicleContainerLowFrequency_chosen = 1;
    
    // Methods for field "basicVehicleContainerLowFrequency"
    public static LowFrequencyContainer createLowFrequencyContainerWithBasicVehicleContainerLowFrequency(BasicVehicleContainerLowFrequency basicVehicleContainerLowFrequency)
    {
	LowFrequencyContainer __object = new LowFrequencyContainer();

	__object.setBasicVehicleContainerLowFrequency(basicVehicleContainerLowFrequency);
	return __object;
    }
    
    public boolean hasBasicVehicleContainerLowFrequency()
    {
	return getChosenFlag() == basicVehicleContainerLowFrequency_chosen;
    }
    
    public void setBasicVehicleContainerLowFrequency(BasicVehicleContainerLowFrequency basicVehicleContainerLowFrequency)
    {
	setChosenValue(basicVehicleContainerLowFrequency);
	setChosenFlag(basicVehicleContainerLowFrequency_chosen);
    }
    
    
    // Method to create a specific choice instance
    public AbstractData createInstance(int chosen)
    {
	switch (chosen) {
	    case basicVehicleContainerLowFrequency_chosen:
		return new BasicVehicleContainerLowFrequency();
	    default:
		throw new InternalError("Choice.createInstance()");
	}
	
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final ChoiceInfo c_typeinfo = new ChoiceInfo (
	new Tags (
	    null
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
	    "LowFrequencyContainer"
	),
	new QName (
	    "CAM-PDU-Descriptions",
	    "LowFrequencyContainer"
	),
	12318,
	null,
	new Fields (
	    new FieldInfo[] {
		new FieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				"BasicVehicleContainerLowFrequency"
			    ),
			    new QName (
				"CAM-PDU-Descriptions",
				"BasicVehicleContainerLowFrequency"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				    "BasicVehicleContainerLowFrequency"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				    "BasicVehicleContainerLowFrequency"
				)
			    ),
			    0
			)
		    ),
		    "basicVehicleContainerLowFrequency",
		    0,
		    2
		)
	    }
	),
	0,
	new TagDecoder (
	    new TagDecoderElement[] {
		new TagDecoderElement((short)0x8000, 0)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' LowFrequencyContainer object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' LowFrequencyContainer object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Check the current selection on unknown extension
     */
    public final boolean hasUnknownExtension()
    {
	return getChosenFlag() > 1;
    }
    
} // End class definition for LowFrequencyContainer
