/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type PublicTransportContainer from ASN1 Module CAM_PDU_Descriptions.
 * @see Sequence
 */

public class PublicTransportContainer extends Sequence {
    
    /**
     * The default constructor.
     */
    public PublicTransportContainer()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public PublicTransportContainer(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmbarkationStatus embarkationStatus, 
		    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PtActivation ptActivation)
    {
	setEmbarkationStatus(embarkationStatus);
	setPtActivation(ptActivation);
    }
    
    /**
     * Construct with required components.
     */
    public PublicTransportContainer(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmbarkationStatus embarkationStatus)
    {
	setEmbarkationStatus(embarkationStatus);
    }
    
    public void initComponents()
    {
	mComponents[0] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmbarkationStatus();
	mComponents[1] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PtActivation();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmbarkationStatus();
	    case 1:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PtActivation();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "embarkationStatus"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmbarkationStatus getEmbarkationStatus()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmbarkationStatus)mComponents[0];
    }
    
    public void setEmbarkationStatus(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmbarkationStatus embarkationStatus)
    {
	mComponents[0] = embarkationStatus;
    }
    
    
    // Methods for field "ptActivation"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PtActivation getPtActivation()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PtActivation)mComponents[1];
    }
    
    public void setPtActivation(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PtActivation ptActivation)
    {
	mComponents[1] = ptActivation;
    }
    
    public boolean hasPtActivation()
    {
	return componentIsPresent(1);
    }
    
    public void deletePtActivation()
    {
	setComponentAbsent(1);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
	    "PublicTransportContainer"
	),
	new QName (
	    "CAM-PDU-Descriptions",
	    "PublicTransportContainer"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new TypeInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"EmbarkationStatus"
			    ),
			    new QName (
				"ITS-Container",
				"EmbarkationStatus"
			    ),
			    12314,
			    null
			)
		    ),
		    "embarkationStatus",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"PtActivation"
			    ),
			    new QName (
				"ITS-Container",
				"PtActivation"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "PtActivation"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "PtActivation"
				)
			    ),
			    0
			)
		    ),
		    "ptActivation",
		    1,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' PublicTransportContainer object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' PublicTransportContainer object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for PublicTransportContainer
