/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type RoadWorksContainerBasic from ASN1 Module CAM_PDU_Descriptions.
 * @see Sequence
 */

public class RoadWorksContainerBasic extends Sequence {
    
    /**
     * The default constructor.
     */
    public RoadWorksContainerBasic()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public RoadWorksContainerBasic(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RoadworksSubCauseCode roadworksSubCauseCode, 
		    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse lightBarSirenInUse, 
		    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ClosedLanes closedLanes)
    {
	setRoadworksSubCauseCode(roadworksSubCauseCode);
	setLightBarSirenInUse(lightBarSirenInUse);
	setClosedLanes(closedLanes);
    }
    
    /**
     * Construct with required components.
     */
    public RoadWorksContainerBasic(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse lightBarSirenInUse)
    {
	setLightBarSirenInUse(lightBarSirenInUse);
    }
    
    public void initComponents()
    {
	mComponents[0] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RoadworksSubCauseCode();
	mComponents[1] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse();
	mComponents[2] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ClosedLanes();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[3];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RoadworksSubCauseCode();
	    case 1:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse();
	    case 2:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ClosedLanes();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "roadworksSubCauseCode"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RoadworksSubCauseCode getRoadworksSubCauseCode()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RoadworksSubCauseCode)mComponents[0];
    }
    
    public void setRoadworksSubCauseCode(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RoadworksSubCauseCode roadworksSubCauseCode)
    {
	mComponents[0] = roadworksSubCauseCode;
    }
    
    public boolean hasRoadworksSubCauseCode()
    {
	return componentIsPresent(0);
    }
    
    public void deleteRoadworksSubCauseCode()
    {
	setComponentAbsent(0);
    }
    
    
    // Methods for field "lightBarSirenInUse"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse getLightBarSirenInUse()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse)mComponents[1];
    }
    
    public void setLightBarSirenInUse(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse lightBarSirenInUse)
    {
	mComponents[1] = lightBarSirenInUse;
    }
    
    
    // Methods for field "closedLanes"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ClosedLanes getClosedLanes()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ClosedLanes)mComponents[2];
    }
    
    public void setClosedLanes(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ClosedLanes closedLanes)
    {
	mComponents[2] = closedLanes;
    }
    
    public boolean hasClosedLanes()
    {
	return componentIsPresent(2);
    }
    
    public void deleteClosedLanes()
    {
	setComponentAbsent(2);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
	    "RoadWorksContainerBasic"
	),
	new QName (
	    "CAM-PDU-Descriptions",
	    "RoadWorksContainerBasic"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"RoadworksSubCauseCode"
			    ),
			    new QName (
				"ITS-Container",
				"RoadworksSubCauseCode"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RoadworksSubCauseCode(0), 
				    new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RoadworksSubCauseCode(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"unavailable",
					0
				    ),
				    new MemberListElement (
					"majorRoadworks",
					1
				    ),
				    new MemberListElement (
					"roadMarkingWork",
					2
				    ),
				    new MemberListElement (
					"slowMovingRoadMaintenance",
					3
				    ),
				    new MemberListElement (
					"winterService",
					4
				    ),
				    new MemberListElement (
					"streetCleaning",
					5
				    )
				}
			    )
			)
		    ),
		    "roadworksSubCauseCode",
		    0,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"LightBarSirenInUse"
			    ),
			    new QName (
				"ITS-Container",
				"LightBarSirenInUse"
			    ),
			    12314,
			    new SizeConstraint (
				new SingleValueConstraint (
				    new com.oss.asn1.INTEGER(2)
				)
			    ),
			    new Bounds (
				new java.lang.Long(2),
				new java.lang.Long(2)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"lightBarActivated",
					0
				    ),
				    new MemberListElement (
					"sirenActivated",
					1
				    )
				}
			    )
			)
		    ),
		    "lightBarSirenInUse",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"ClosedLanes"
			    ),
			    new QName (
				"ITS-Container",
				"ClosedLanes"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "ClosedLanes"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "ClosedLanes"
				)
			    ),
			    0
			)
		    ),
		    "closedLanes",
		    2,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0),
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' RoadWorksContainerBasic object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' RoadWorksContainerBasic object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for RoadWorksContainerBasic
