/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type SafetyCarContainer from ASN1 Module CAM_PDU_Descriptions.
 * @see Sequence
 */

public class SafetyCarContainer extends Sequence {
    
    /**
     * The default constructor.
     */
    public SafetyCarContainer()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public SafetyCarContainer(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse lightBarSirenInUse, 
		    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CauseCode incidentIndication, 
		    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TrafficRule trafficRule, 
		    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedLimit speedLimit)
    {
	setLightBarSirenInUse(lightBarSirenInUse);
	setIncidentIndication(incidentIndication);
	setTrafficRule(trafficRule);
	setSpeedLimit(speedLimit);
    }
    
    /**
     * Construct with required components.
     */
    public SafetyCarContainer(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse lightBarSirenInUse)
    {
	setLightBarSirenInUse(lightBarSirenInUse);
    }
    
    public void initComponents()
    {
	mComponents[0] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse();
	mComponents[1] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CauseCode();
	mComponents[2] = org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TrafficRule.noPassing;
	mComponents[3] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedLimit();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[4];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse();
	    case 1:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CauseCode();
	    case 2:
		return org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TrafficRule.noPassing;
	    case 3:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedLimit();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "lightBarSirenInUse"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse getLightBarSirenInUse()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse)mComponents[0];
    }
    
    public void setLightBarSirenInUse(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse lightBarSirenInUse)
    {
	mComponents[0] = lightBarSirenInUse;
    }
    
    
    // Methods for field "incidentIndication"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CauseCode getIncidentIndication()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CauseCode)mComponents[1];
    }
    
    public void setIncidentIndication(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CauseCode incidentIndication)
    {
	mComponents[1] = incidentIndication;
    }
    
    public boolean hasIncidentIndication()
    {
	return componentIsPresent(1);
    }
    
    public void deleteIncidentIndication()
    {
	setComponentAbsent(1);
    }
    
    
    // Methods for field "trafficRule"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TrafficRule getTrafficRule()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TrafficRule)mComponents[2];
    }
    
    public void setTrafficRule(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TrafficRule trafficRule)
    {
	mComponents[2] = trafficRule;
    }
    
    public boolean hasTrafficRule()
    {
	return componentIsPresent(2);
    }
    
    public void deleteTrafficRule()
    {
	setComponentAbsent(2);
    }
    
    
    // Methods for field "speedLimit"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedLimit getSpeedLimit()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedLimit)mComponents[3];
    }
    
    public void setSpeedLimit(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedLimit speedLimit)
    {
	mComponents[3] = speedLimit;
    }
    
    public boolean hasSpeedLimit()
    {
	return componentIsPresent(3);
    }
    
    public void deleteSpeedLimit()
    {
	setComponentAbsent(3);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
	    "SafetyCarContainer"
	),
	new QName (
	    "CAM-PDU-Descriptions",
	    "SafetyCarContainer"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"LightBarSirenInUse"
			    ),
			    new QName (
				"ITS-Container",
				"LightBarSirenInUse"
			    ),
			    12314,
			    new SizeConstraint (
				new SingleValueConstraint (
				    new com.oss.asn1.INTEGER(2)
				)
			    ),
			    new Bounds (
				new java.lang.Long(2),
				new java.lang.Long(2)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"lightBarActivated",
					0
				    ),
				    new MemberListElement (
					"sirenActivated",
					1
				    )
				}
			    )
			)
		    ),
		    "lightBarSirenInUse",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"CauseCode"
			    ),
			    new QName (
				"ITS-Container",
				"CauseCode"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "CauseCode"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "CauseCode"
				)
			    ),
			    0
			)
		    ),
		    "incidentIndication",
		    1,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"TrafficRule"
			    ),
			    new QName (
				"ITS-Container",
				"TrafficRule"
			    ),
			    12318,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"noPassing",
					0
				    ),
				    new MemberListElement (
					"noPassingForTrucks",
					1
				    )
				}
			    ),
			    0,
			    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TrafficRule.noPassing
			)
		    ),
		    "trafficRule",
		    2,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"SpeedLimit"
			    ),
			    new QName (
				"ITS-Container",
				"SpeedLimit"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedLimit(0), 
				    new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedLimit(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneKmPerHour",
					1
				    )
				}
			    )
			)
		    ),
		    "speedLimit",
		    3,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' SafetyCarContainer object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' SafetyCarContainer object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for SafetyCarContainer
