/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type CauseCodeType from ASN1 Module ITS_Container.
 * @see INTEGER
 */

public class CauseCodeType extends INTEGER {
    
    /**
     * The default constructor.
     */
    public CauseCodeType()
    {
    }
    
    public CauseCodeType(short value)
    {
	super(value);
    }
    
    public CauseCodeType(int value)
    {
	super(value);
    }
    
    public CauseCodeType(long value)
    {
	super(value);
    }
    
    // Named list definitions.
    public static final CauseCodeType reserved =
	new CauseCodeType(0);
    public static final CauseCodeType trafficCondition =
	new CauseCodeType(1);
    public static final CauseCodeType accident =
	new CauseCodeType(2);
    public static final CauseCodeType roadworks =
	new CauseCodeType(3);
    public static final CauseCodeType adverseWeatherCondition_Adhesion =
	new CauseCodeType(6);
    public static final CauseCodeType hazardousLocation_SurfaceCondition =
	new CauseCodeType(9);
    public static final CauseCodeType hazardousLocation_ObstacleOnTheRoad =
	new CauseCodeType(10);
    public static final CauseCodeType hazardousLocation_AnimalOnTheRoad =
	new CauseCodeType(11);
    public static final CauseCodeType humanPresenceOnTheRoad =
	new CauseCodeType(12);
    public static final CauseCodeType wrongWayDriving =
	new CauseCodeType(14);
    public static final CauseCodeType rescueAndRecoveryWorkInProgress =
	new CauseCodeType(15);
    public static final CauseCodeType adverseWeatherCondition_ExtremeWeatherCondition =
	new CauseCodeType(17);
    public static final CauseCodeType adverseWeatherCondition_Visibility =
	new CauseCodeType(18);
    public static final CauseCodeType adverseWeatherCondition_Precipitation =
	new CauseCodeType(19);
    public static final CauseCodeType slowVehicle =
	new CauseCodeType(26);
    public static final CauseCodeType dangerousEndOfQueue =
	new CauseCodeType(27);
    public static final CauseCodeType vehicleBreakdown =
	new CauseCodeType(91);
    public static final CauseCodeType postCrash =
	new CauseCodeType(92);
    public static final CauseCodeType humanProblem =
	new CauseCodeType(93);
    public static final CauseCodeType stationaryVehicle =
	new CauseCodeType(94);
    public static final CauseCodeType emergencyVehicleApproaching =
	new CauseCodeType(95);
    public static final CauseCodeType hazardousLocation_DangerousCurve =
	new CauseCodeType(96);
    public static final CauseCodeType collisionRisk =
	new CauseCodeType(97);
    public static final CauseCodeType signalViolation =
	new CauseCodeType(98);
    public static final CauseCodeType dangerousSituation =
	new CauseCodeType(99);
    private final static CauseCodeType cNamedNumbers[] = {
	 reserved, 
	 trafficCondition, 
	 accident, 
	 roadworks, 
	 adverseWeatherCondition_Adhesion, 
	 hazardousLocation_SurfaceCondition, 
	 hazardousLocation_ObstacleOnTheRoad, 
	 hazardousLocation_AnimalOnTheRoad, 
	 humanPresenceOnTheRoad, 
	 wrongWayDriving, 
	 rescueAndRecoveryWorkInProgress, 
	 adverseWeatherCondition_ExtremeWeatherCondition, 
	 adverseWeatherCondition_Visibility, 
	 adverseWeatherCondition_Precipitation, 
	 slowVehicle, 
	 dangerousEndOfQueue, 
	 vehicleBreakdown, 
	 postCrash, 
	 humanProblem, 
	 stationaryVehicle, 
	 emergencyVehicleApproaching, 
	 hazardousLocation_DangerousCurve, 
	 collisionRisk, 
	 signalViolation, 
	 dangerousSituation
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public INTEGER[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final IntegerInfo c_typeinfo = new IntegerInfo (
	new Tags (
	    new short[] {
		0x0002
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
	    "CauseCodeType"
	),
	new QName (
	    "ITS-Container",
	    "CauseCodeType"
	),
	12314,
	new ValueRangeConstraint (
	    new AbstractBounds(
		new CauseCodeType(0), 
		new CauseCodeType(255),
		0
	    )
	),
	new Bounds (
	    new java.lang.Long(0),
	    new java.lang.Long(255)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "reserved",
		    0
		),
		new MemberListElement (
		    "trafficCondition",
		    1
		),
		new MemberListElement (
		    "accident",
		    2
		),
		new MemberListElement (
		    "roadworks",
		    3
		),
		new MemberListElement (
		    "adverseWeatherCondition-Adhesion",
		    6
		),
		new MemberListElement (
		    "hazardousLocation-SurfaceCondition",
		    9
		),
		new MemberListElement (
		    "hazardousLocation-ObstacleOnTheRoad",
		    10
		),
		new MemberListElement (
		    "hazardousLocation-AnimalOnTheRoad",
		    11
		),
		new MemberListElement (
		    "humanPresenceOnTheRoad",
		    12
		),
		new MemberListElement (
		    "wrongWayDriving",
		    14
		),
		new MemberListElement (
		    "rescueAndRecoveryWorkInProgress",
		    15
		),
		new MemberListElement (
		    "adverseWeatherCondition-ExtremeWeatherCondition",
		    17
		),
		new MemberListElement (
		    "adverseWeatherCondition-Visibility",
		    18
		),
		new MemberListElement (
		    "adverseWeatherCondition-Precipitation",
		    19
		),
		new MemberListElement (
		    "slowVehicle",
		    26
		),
		new MemberListElement (
		    "dangerousEndOfQueue",
		    27
		),
		new MemberListElement (
		    "vehicleBreakdown",
		    91
		),
		new MemberListElement (
		    "postCrash",
		    92
		),
		new MemberListElement (
		    "humanProblem",
		    93
		),
		new MemberListElement (
		    "stationaryVehicle",
		    94
		),
		new MemberListElement (
		    "emergencyVehicleApproaching",
		    95
		),
		new MemberListElement (
		    "hazardousLocation-DangerousCurve",
		    96
		),
		new MemberListElement (
		    "collisionRisk",
		    97
		),
		new MemberListElement (
		    "signalViolation",
		    98
		),
		new MemberListElement (
		    "dangerousSituation",
		    99
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' CauseCodeType object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' CauseCodeType object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for CauseCodeType
