/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type Curvature from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class Curvature extends Sequence {
    
    /**
     * The default constructor.
     */
    public Curvature()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public Curvature(CurvatureValue curvatureValue, 
		    CurvatureConfidence curvatureConfidence)
    {
	setCurvatureValue(curvatureValue);
	setCurvatureConfidence(curvatureConfidence);
    }
    
    public void initComponents()
    {
	mComponents[0] = new CurvatureValue();
	mComponents[1] = CurvatureConfidence.onePerMeter_0_00002;
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new CurvatureValue();
	    case 1:
		return CurvatureConfidence.onePerMeter_0_00002;
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "curvatureValue"
    public CurvatureValue getCurvatureValue()
    {
	return (CurvatureValue)mComponents[0];
    }
    
    public void setCurvatureValue(CurvatureValue curvatureValue)
    {
	mComponents[0] = curvatureValue;
    }
    
    
    // Methods for field "curvatureConfidence"
    public CurvatureConfidence getCurvatureConfidence()
    {
	return (CurvatureConfidence)mComponents[1];
    }
    
    public void setCurvatureConfidence(CurvatureConfidence curvatureConfidence)
    {
	mComponents[1] = curvatureConfidence;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
	    "Curvature"
	),
	new QName (
	    "ITS-Container",
	    "Curvature"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"CurvatureValue"
			    ),
			    new QName (
				"ITS-Container",
				"CurvatureValue"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new CurvatureValue(-30000), 
				    new CurvatureValue(30001),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-30000),
				new java.lang.Long(30001)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"straight",
					0
				    ),
				    new MemberListElement (
					"reciprocalOf1MeterRadiusToRight",
					-30000
				    ),
				    new MemberListElement (
					"reciprocalOf1MeterRadiusToLeft",
					30000
				    ),
				    new MemberListElement (
					"unavailable",
					30001
				    )
				}
			    )
			)
		    ),
		    "curvatureValue",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"CurvatureConfidence"
			    ),
			    new QName (
				"ITS-Container",
				"CurvatureConfidence"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"onePerMeter-0-00002",
					0
				    ),
				    new MemberListElement (
					"onePerMeter-0-0001",
					1
				    ),
				    new MemberListElement (
					"onePerMeter-0-0005",
					2
				    ),
				    new MemberListElement (
					"onePerMeter-0-002",
					3
				    ),
				    new MemberListElement (
					"onePerMeter-0-01",
					4
				    ),
				    new MemberListElement (
					"onePerMeter-0-1",
					5
				    ),
				    new MemberListElement (
					"outOfRange",
					6
				    ),
				    new MemberListElement (
					"unavailable",
					7
				    )
				}
			    ),
			    0,
			    CurvatureConfidence.onePerMeter_0_00002
			)
		    ),
		    "curvatureConfidence",
		    1,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' Curvature object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' Curvature object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for Curvature
