/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type PositionOfOccupants from ASN1 Module ITS_Container.
 * @see BitString
 */

public class PositionOfOccupants extends BitString {
    
    /**
     * The default constructor.
     */
    public PositionOfOccupants()
    {
    }
    
    /**
     * Construct Bit String from a byte array.
     * All bits considered significant.
     * @param value the byte array to set this object to.
     */
    public PositionOfOccupants(byte[] value)
    {
	super(value);
    }
    
    
    /**
     * Construct Bit String from a byte array and significant bits.
     * @param value the byte array to set this object to.
     * @param sigBits the number of significant bits.
     */
    public PositionOfOccupants(byte[] value, int sigBits)
    {
	super(value, sigBits);
    }
    
    // Named list definitions.
    public static final int row1LeftOccupied = 0;
    public static final int row1RightOccupied = 1;
    public static final int row1MidOccupied = 2;
    public static final int row1NotDetectable = 3;
    public static final int row1NotPresent = 4;
    public static final int row2LeftOccupied = 5;
    public static final int row2RightOccupied = 6;
    public static final int row2MidOccupied = 7;
    public static final int row2NotDetectable = 8;
    public static final int row2NotPresent = 9;
    public static final int row3LeftOccupied = 10;
    public static final int row3RightOccupied = 11;
    public static final int row3MidOccupied = 12;
    public static final int row3NotDetectable = 13;
    public static final int row3NotPresent = 14;
    public static final int row4LeftOccupied = 15;
    public static final int row4RightOccupied = 16;
    public static final int row4MidOccupied = 17;
    public static final int row4NotDetectable = 18;
    public static final int row4NotPresent = 19;
    
    /**
     * Initialize the type descriptor.
     */
    private static final BitStringInfo c_typeinfo = new BitStringInfo (
	new Tags (
	    new short[] {
		0x0003
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
	    "PositionOfOccupants"
	),
	new QName (
	    "ITS-Container",
	    "PositionOfOccupants"
	),
	12314,
	new SizeConstraint (
	    new SingleValueConstraint (
		new com.oss.asn1.INTEGER(20)
	    )
	),
	new Bounds (
	    new java.lang.Long(20),
	    new java.lang.Long(20)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "row1LeftOccupied",
		    0
		),
		new MemberListElement (
		    "row1RightOccupied",
		    1
		),
		new MemberListElement (
		    "row1MidOccupied",
		    2
		),
		new MemberListElement (
		    "row1NotDetectable",
		    3
		),
		new MemberListElement (
		    "row1NotPresent",
		    4
		),
		new MemberListElement (
		    "row2LeftOccupied",
		    5
		),
		new MemberListElement (
		    "row2RightOccupied",
		    6
		),
		new MemberListElement (
		    "row2MidOccupied",
		    7
		),
		new MemberListElement (
		    "row2NotDetectable",
		    8
		),
		new MemberListElement (
		    "row2NotPresent",
		    9
		),
		new MemberListElement (
		    "row3LeftOccupied",
		    10
		),
		new MemberListElement (
		    "row3RightOccupied",
		    11
		),
		new MemberListElement (
		    "row3MidOccupied",
		    12
		),
		new MemberListElement (
		    "row3NotDetectable",
		    13
		),
		new MemberListElement (
		    "row3NotPresent",
		    14
		),
		new MemberListElement (
		    "row4LeftOccupied",
		    15
		),
		new MemberListElement (
		    "row4RightOccupied",
		    16
		),
		new MemberListElement (
		    "row4MidOccupied",
		    17
		),
		new MemberListElement (
		    "row4NotDetectable",
		    18
		),
		new MemberListElement (
		    "row4NotPresent",
		    19
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' PositionOfOccupants object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' PositionOfOccupants object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for PositionOfOccupants
