/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type VerticalAcceleration from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class VerticalAcceleration extends Sequence {
    
    /**
     * The default constructor.
     */
    public VerticalAcceleration()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public VerticalAcceleration(VerticalAccelerationValue verticalAccelerationValue, 
		    AccelerationConfidence verticalAccelerationConfidence)
    {
	setVerticalAccelerationValue(verticalAccelerationValue);
	setVerticalAccelerationConfidence(verticalAccelerationConfidence);
    }
    
    public void initComponents()
    {
	mComponents[0] = new VerticalAccelerationValue();
	mComponents[1] = new AccelerationConfidence();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new VerticalAccelerationValue();
	    case 1:
		return new AccelerationConfidence();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "verticalAccelerationValue"
    public VerticalAccelerationValue getVerticalAccelerationValue()
    {
	return (VerticalAccelerationValue)mComponents[0];
    }
    
    public void setVerticalAccelerationValue(VerticalAccelerationValue verticalAccelerationValue)
    {
	mComponents[0] = verticalAccelerationValue;
    }
    
    
    // Methods for field "verticalAccelerationConfidence"
    public AccelerationConfidence getVerticalAccelerationConfidence()
    {
	return (AccelerationConfidence)mComponents[1];
    }
    
    public void setVerticalAccelerationConfidence(AccelerationConfidence verticalAccelerationConfidence)
    {
	mComponents[1] = verticalAccelerationConfidence;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
	    "VerticalAcceleration"
	),
	new QName (
	    "ITS-Container",
	    "VerticalAcceleration"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"VerticalAccelerationValue"
			    ),
			    new QName (
				"ITS-Container",
				"VerticalAccelerationValue"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new VerticalAccelerationValue(-160), 
				    new VerticalAccelerationValue(161),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-160),
				new java.lang.Long(161)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"pointOneMeterPerSecSquaredUp",
					1
				    ),
				    new MemberListElement (
					"pointOneMeterPerSecSquaredDown",
					-1
				    ),
				    new MemberListElement (
					"unavailable",
					161
				    )
				}
			    )
			)
		    ),
		    "verticalAccelerationValue",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"AccelerationConfidence"
			    ),
			    new QName (
				"ITS-Container",
				"AccelerationConfidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new AccelerationConfidence(0), 
				    new AccelerationConfidence(102),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(102)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"pointOneMeterPerSecSquared",
					1
				    ),
				    new MemberListElement (
					"outOfRange",
					101
				    ),
				    new MemberListElement (
					"unavailable",
					102
				    )
				}
			    )
			)
		    ),
		    "verticalAccelerationConfidence",
		    1,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' VerticalAcceleration object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' VerticalAcceleration object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for VerticalAcceleration
