/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type AdverseWeatherCondition_AdhesionSubCauseCode from ASN1 Module ITS_Container.
 * @see INTEGER
 */

public class AdverseWeatherCondition_AdhesionSubCauseCode extends INTEGER {
    
    /**
     * The default constructor.
     */
    public AdverseWeatherCondition_AdhesionSubCauseCode()
    {
    }
    
    public AdverseWeatherCondition_AdhesionSubCauseCode(short value)
    {
	super(value);
    }
    
    public AdverseWeatherCondition_AdhesionSubCauseCode(int value)
    {
	super(value);
    }
    
    public AdverseWeatherCondition_AdhesionSubCauseCode(long value)
    {
	super(value);
    }
    
    // Named list definitions.
    public static final AdverseWeatherCondition_AdhesionSubCauseCode unavailable =
	new AdverseWeatherCondition_AdhesionSubCauseCode(0);
    public static final AdverseWeatherCondition_AdhesionSubCauseCode heavyFrostOnRoad =
	new AdverseWeatherCondition_AdhesionSubCauseCode(1);
    public static final AdverseWeatherCondition_AdhesionSubCauseCode fuelOnRoad =
	new AdverseWeatherCondition_AdhesionSubCauseCode(2);
    public static final AdverseWeatherCondition_AdhesionSubCauseCode mudOnRoad =
	new AdverseWeatherCondition_AdhesionSubCauseCode(3);
    public static final AdverseWeatherCondition_AdhesionSubCauseCode snowOnRoad =
	new AdverseWeatherCondition_AdhesionSubCauseCode(4);
    public static final AdverseWeatherCondition_AdhesionSubCauseCode iceOnRoad =
	new AdverseWeatherCondition_AdhesionSubCauseCode(5);
    public static final AdverseWeatherCondition_AdhesionSubCauseCode blackIceOnRoad =
	new AdverseWeatherCondition_AdhesionSubCauseCode(6);
    public static final AdverseWeatherCondition_AdhesionSubCauseCode oilOnRoad =
	new AdverseWeatherCondition_AdhesionSubCauseCode(7);
    public static final AdverseWeatherCondition_AdhesionSubCauseCode looseChippings =
	new AdverseWeatherCondition_AdhesionSubCauseCode(8);
    public static final AdverseWeatherCondition_AdhesionSubCauseCode instantBlackIce =
	new AdverseWeatherCondition_AdhesionSubCauseCode(9);
    public static final AdverseWeatherCondition_AdhesionSubCauseCode roadsSalted =
	new AdverseWeatherCondition_AdhesionSubCauseCode(10);
    private final static AdverseWeatherCondition_AdhesionSubCauseCode cNamedNumbers[] = {
	 unavailable, 
	 heavyFrostOnRoad, 
	 fuelOnRoad, 
	 mudOnRoad, 
	 snowOnRoad, 
	 iceOnRoad, 
	 blackIceOnRoad, 
	 oilOnRoad, 
	 looseChippings, 
	 instantBlackIce, 
	 roadsSalted
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public INTEGER[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final IntegerInfo c_typeinfo = new IntegerInfo (
	new Tags (
	    new short[] {
		0x0002
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "AdverseWeatherCondition_AdhesionSubCauseCode"
	),
	new QName (
	    "ITS-Container",
	    "AdverseWeatherCondition-AdhesionSubCauseCode"
	),
	12314,
	new ValueRangeConstraint (
	    new AbstractBounds(
		new AdverseWeatherCondition_AdhesionSubCauseCode(0), 
		new AdverseWeatherCondition_AdhesionSubCauseCode(255),
		0
	    )
	),
	new Bounds (
	    new java.lang.Long(0),
	    new java.lang.Long(255)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "unavailable",
		    0
		),
		new MemberListElement (
		    "heavyFrostOnRoad",
		    1
		),
		new MemberListElement (
		    "fuelOnRoad",
		    2
		),
		new MemberListElement (
		    "mudOnRoad",
		    3
		),
		new MemberListElement (
		    "snowOnRoad",
		    4
		),
		new MemberListElement (
		    "iceOnRoad",
		    5
		),
		new MemberListElement (
		    "blackIceOnRoad",
		    6
		),
		new MemberListElement (
		    "oilOnRoad",
		    7
		),
		new MemberListElement (
		    "looseChippings",
		    8
		),
		new MemberListElement (
		    "instantBlackIce",
		    9
		),
		new MemberListElement (
		    "roadsSalted",
		    10
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' AdverseWeatherCondition_AdhesionSubCauseCode object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' AdverseWeatherCondition_AdhesionSubCauseCode object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for AdverseWeatherCondition_AdhesionSubCauseCode
