/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type DeltaReferencePosition from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class DeltaReferencePosition extends Sequence {
    
    /**
     * The default constructor.
     */
    public DeltaReferencePosition()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public DeltaReferencePosition(DeltaLatitude deltaLatitude, 
		    DeltaLongitude deltaLongitude, 
		    DeltaElevation deltaElevation)
    {
	setDeltaLatitude(deltaLatitude);
	setDeltaLongitude(deltaLongitude);
	setDeltaElevation(deltaElevation);
    }
    
    public void initComponents()
    {
	mComponents[0] = new DeltaLatitude();
	mComponents[1] = new DeltaLongitude();
	mComponents[2] = new DeltaElevation();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[3];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new DeltaLatitude();
	    case 1:
		return new DeltaLongitude();
	    case 2:
		return new DeltaElevation();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "deltaLatitude"
    public DeltaLatitude getDeltaLatitude()
    {
	return (DeltaLatitude)mComponents[0];
    }
    
    public void setDeltaLatitude(DeltaLatitude deltaLatitude)
    {
	mComponents[0] = deltaLatitude;
    }
    
    
    // Methods for field "deltaLongitude"
    public DeltaLongitude getDeltaLongitude()
    {
	return (DeltaLongitude)mComponents[1];
    }
    
    public void setDeltaLongitude(DeltaLongitude deltaLongitude)
    {
	mComponents[1] = deltaLongitude;
    }
    
    
    // Methods for field "deltaElevation"
    public DeltaElevation getDeltaElevation()
    {
	return (DeltaElevation)mComponents[2];
    }
    
    public void setDeltaElevation(DeltaElevation deltaElevation)
    {
	mComponents[2] = deltaElevation;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "DeltaReferencePosition"
	),
	new QName (
	    "ITS-Container",
	    "DeltaReferencePosition"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				"DeltaLatitude"
			    ),
			    new QName (
				"ITS-Container",
				"DeltaLatitude"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new DeltaLatitude(-131072), 
				    new DeltaLatitude(131071),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-131072),
				new java.lang.Long(131071)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneMicrodegreeNorth",
					10
				    ),
				    new MemberListElement (
					"oneMicrodegreeSouth",
					-10
				    )
				}
			    )
			)
		    ),
		    "deltaLatitude",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				"DeltaLongitude"
			    ),
			    new QName (
				"ITS-Container",
				"DeltaLongitude"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new DeltaLongitude(-131072), 
				    new DeltaLongitude(131071),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-131072),
				new java.lang.Long(131071)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneMicrodegreeEast",
					10
				    ),
				    new MemberListElement (
					"oneMicrodegreeWest",
					-10
				    )
				}
			    )
			)
		    ),
		    "deltaLongitude",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				"DeltaElevation"
			    ),
			    new QName (
				"ITS-Container",
				"DeltaElevation"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new DeltaElevation(-127), 
				    new DeltaElevation(128),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-127),
				new java.lang.Long(128)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneMeterUp",
					1
				    ),
				    new MemberListElement (
					"oneMeterDown",
					-1
				    ),
				    new MemberListElement (
					"unavailable",
					128
				    )
				}
			    )
			)
		    ),
		    "deltaElevation",
		    2,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' DeltaReferencePosition object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' DeltaReferencePosition object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for DeltaReferencePosition
