/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type HardShoulderStatus from ASN1 Module ITS_Container.
 * @see Enumerated
 */

public final class HardShoulderStatus extends Enumerated {
    
    /**
     * The default constructor.
     */
    private HardShoulderStatus()
    {
	super(cFirstNumber);
    }
    
    protected HardShoulderStatus(long value)
    {
	super(value);
    }
    
    public static final class Value {
	public static final long availableForStopping = 0;
	public static final long closed = 1;
	public static final long availableForDriving = 2;
    }
    // Named list definitions.
    public static final HardShoulderStatus availableForStopping =
	new HardShoulderStatus();
    public static final HardShoulderStatus closed =
	new HardShoulderStatus(1);
    public static final HardShoulderStatus availableForDriving =
	new HardShoulderStatus(2);
    private final static HardShoulderStatus cNamedNumbers[] = {
	 availableForStopping, 
	 closed, 
	 availableForDriving
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public Enumerated[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    public static HardShoulderStatus valueOf(long value)
    {
	return (HardShoulderStatus)availableForStopping.lookupValue(value);
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
	new Tags (
	    new short[] {
		0x000a
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "HardShoulderStatus"
	),
	new QName (
	    "ITS-Container",
	    "HardShoulderStatus"
	),
	12314,
	null,
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "availableForStopping",
		    0
		),
		new MemberListElement (
		    "closed",
		    1
		),
		new MemberListElement (
		    "availableForDriving",
		    2
		)
	    }
	),
	0,
	availableForStopping
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' HardShoulderStatus object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' HardShoulderStatus object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for HardShoulderStatus
