/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type ItsPduHeader from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class ItsPduHeader extends Sequence {
    
    /**
     * The default constructor.
     */
    public ItsPduHeader()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public ItsPduHeader(_0 protocolVersion, _1 messageID, StationID stationID)
    {
	setProtocolVersion(protocolVersion);
	setMessageID(messageID);
	setStationID(stationID);
    }
    
    public void initComponents()
    {
	mComponents[0] = new _0();
	mComponents[1] = new _1();
	mComponents[2] = new StationID();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[3];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new _0();
	    case 1:
		return new _1();
	    case 2:
		return new StationID();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "protocolVersion"
    public _0 getProtocolVersion()
    {
	return (_0)mComponents[0];
    }
    
    public void setProtocolVersion(_0 protocolVersion)
    {
	mComponents[0] = protocolVersion;
    }
    
    
    
    /**
     * Define the ASN1 Type _0 from ASN1 Module ITS_Container.
     * @see INTEGER
     */
    public static class _0 extends INTEGER {
	
	/**
	 * The default constructor.
	 */
	public _0()
	{
	}
	
	public _0(short value)
	{
	    super(value);
	}
	
	public _0(int value)
	{
	    super(value);
	}
	
	public _0(long value)
	{
	    super(value);
	}
	
	// Named list definitions.
	public static final _0 currentVersion =
	    new _0(1);
	private final static _0 cNamedNumbers[] = {
	     currentVersion
	};
	protected final static long cFirstNumber = 1;
	protected final static boolean cLinearNumbers = false;
	
	public INTEGER[] getNamedNumbers()
	{
	    return cNamedNumbers;
	}
	
	public boolean hasLinearNumbers()
	{
	    return cLinearNumbers;
	}
	
	public long getFirstNumber()
	{
	    return cFirstNumber;
	}
	
	/**
	 * Initialize the type descriptor.
	 */
	private static final IntegerInfo c_typeinfo = new IntegerInfo (
	    new Tags (
		new short[] {
		    (short)0x8000
		}
	    ),
	    new QName (
		"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
		"ItsPduHeader$_0"
	    ),
	    new QName (
		"builtin",
		"INTEGER"
	    ),
	    12314,
	    new ValueRangeConstraint (
		new AbstractBounds(
		    new ItsPduHeader._0(0), 
		    new ItsPduHeader._0(255),
		    0
		)
	    ),
	    new Bounds (
		new java.lang.Long(0),
		new java.lang.Long(255)
	    ),
	    new MemberList (
		new MemberListElement[] {
		    new MemberListElement (
			"currentVersion",
			1
		    )
		}
	    )
	);
	
	/**
	 * Get the type descriptor (TypeInfo) of 'this' _0 object.
	 */
	public TypeInfo getTypeInfo()
	{
	    return c_typeinfo;
	}
	
	/**
	 * Get the static type descriptor (TypeInfo) of 'this' _0 object.
	 */
	public static TypeInfo getStaticTypeInfo()
	{
	    return c_typeinfo;
	}
	
    } // End class definition for _0

    // Methods for field "messageID"
    public _1 getMessageID()
    {
	return (_1)mComponents[1];
    }
    
    public void setMessageID(_1 messageID)
    {
	mComponents[1] = messageID;
    }
    
    
    
    /**
     * Define the ASN1 Type _1 from ASN1 Module ITS_Container.
     * @see INTEGER
     */
    public static class _1 extends INTEGER {
	
	/**
	 * The default constructor.
	 */
	public _1()
	{
	}
	
	public _1(short value)
	{
	    super(value);
	}
	
	public _1(int value)
	{
	    super(value);
	}
	
	public _1(long value)
	{
	    super(value);
	}
	
	// Named list definitions.
	public static final _1 denm =
	    new _1(1);
	public static final _1 cam =
	    new _1(2);
	public static final _1 poi =
	    new _1(3);
	private final static _1 cNamedNumbers[] = {
	     denm, 
	     cam, 
	     poi
	};
	protected final static long cFirstNumber = 1;
	protected final static boolean cLinearNumbers = false;
	
	public INTEGER[] getNamedNumbers()
	{
	    return cNamedNumbers;
	}
	
	public boolean hasLinearNumbers()
	{
	    return cLinearNumbers;
	}
	
	public long getFirstNumber()
	{
	    return cFirstNumber;
	}
	
	/**
	 * Initialize the type descriptor.
	 */
	private static final IntegerInfo c_typeinfo = new IntegerInfo (
	    new Tags (
		new short[] {
		    (short)0x8001
		}
	    ),
	    new QName (
		"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
		"ItsPduHeader$_1"
	    ),
	    new QName (
		"builtin",
		"INTEGER"
	    ),
	    12314,
	    new ValueRangeConstraint (
		new AbstractBounds(
		    new ItsPduHeader._1(0), 
		    new ItsPduHeader._1(255),
		    0
		)
	    ),
	    new Bounds (
		new java.lang.Long(0),
		new java.lang.Long(255)
	    ),
	    new MemberList (
		new MemberListElement[] {
		    new MemberListElement (
			"denm",
			1
		    ),
		    new MemberListElement (
			"cam",
			2
		    ),
		    new MemberListElement (
			"poi",
			3
		    )
		}
	    )
	);
	
	/**
	 * Get the type descriptor (TypeInfo) of 'this' _1 object.
	 */
	public TypeInfo getTypeInfo()
	{
	    return c_typeinfo;
	}
	
	/**
	 * Get the static type descriptor (TypeInfo) of 'this' _1 object.
	 */
	public static TypeInfo getStaticTypeInfo()
	{
	    return c_typeinfo;
	}
	
    } // End class definition for _1

    // Methods for field "stationID"
    public StationID getStationID()
    {
	return (StationID)mComponents[2];
    }
    
    public void setStationID(StationID stationID)
    {
	mComponents[2] = stationID;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "ItsPduHeader"
	),
	new QName (
	    "ITS-Container",
	    "ItsPduHeader"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new QName (
			    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
			    "ItsPduHeader$_0"
			)
		    ),
		    "protocolVersion",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new QName (
			    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
			    "ItsPduHeader$_1"
			)
		    ),
		    "messageID",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				"StationID"
			    ),
			    new QName (
				"ITS-Container",
				"StationID"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new StationID(0), 
				    new StationID(4294967295L),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(4294967295L)
			    ),
			    null
			)
		    ),
		    "stationID",
		    2,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' ItsPduHeader object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' ItsPduHeader object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for ItsPduHeader
