/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type LateralAccelerationValue from ASN1 Module ITS_Container.
 * @see INTEGER
 */

public class LateralAccelerationValue extends INTEGER {
    
    /**
     * The default constructor.
     */
    public LateralAccelerationValue()
    {
    }
    
    public LateralAccelerationValue(short value)
    {
	super(value);
    }
    
    public LateralAccelerationValue(int value)
    {
	super(value);
    }
    
    public LateralAccelerationValue(long value)
    {
	super(value);
    }
    
    // Named list definitions.
    public static final LateralAccelerationValue pointOneMeterPerSecSquaredToRight =
	new LateralAccelerationValue(-1);
    public static final LateralAccelerationValue pointOneMeterPerSecSquaredToLeft =
	new LateralAccelerationValue(1);
    public static final LateralAccelerationValue unavailable =
	new LateralAccelerationValue(161);
    private final static LateralAccelerationValue cNamedNumbers[] = {
	 pointOneMeterPerSecSquaredToRight, 
	 pointOneMeterPerSecSquaredToLeft, 
	 unavailable
    };
    protected final static long cFirstNumber = -1;
    protected final static boolean cLinearNumbers = false;
    
    public INTEGER[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final IntegerInfo c_typeinfo = new IntegerInfo (
	new Tags (
	    new short[] {
		0x0002
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "LateralAccelerationValue"
	),
	new QName (
	    "ITS-Container",
	    "LateralAccelerationValue"
	),
	12314,
	new ValueRangeConstraint (
	    new AbstractBounds(
		new LateralAccelerationValue(-160), 
		new LateralAccelerationValue(161),
		0
	    )
	),
	new Bounds (
	    new java.lang.Long(-160),
	    new java.lang.Long(161)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "pointOneMeterPerSecSquaredToRight",
		    -1
		),
		new MemberListElement (
		    "pointOneMeterPerSecSquaredToLeft",
		    1
		),
		new MemberListElement (
		    "unavailable",
		    161
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' LateralAccelerationValue object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' LateralAccelerationValue object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for LateralAccelerationValue
