/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type PathPoint from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class PathPoint extends Sequence {
    
    /**
     * The default constructor.
     */
    public PathPoint()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public PathPoint(DeltaReferencePosition pathPosition, 
		    PathDeltaTime pathDeltaTime)
    {
	setPathPosition(pathPosition);
	setPathDeltaTime(pathDeltaTime);
    }
    
    /**
     * Construct with required components.
     */
    public PathPoint(DeltaReferencePosition pathPosition)
    {
	setPathPosition(pathPosition);
    }
    
    public void initComponents()
    {
	mComponents[0] = new DeltaReferencePosition();
	mComponents[1] = new PathDeltaTime();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new DeltaReferencePosition();
	    case 1:
		return new PathDeltaTime();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "pathPosition"
    public DeltaReferencePosition getPathPosition()
    {
	return (DeltaReferencePosition)mComponents[0];
    }
    
    public void setPathPosition(DeltaReferencePosition pathPosition)
    {
	mComponents[0] = pathPosition;
    }
    
    
    // Methods for field "pathDeltaTime"
    public PathDeltaTime getPathDeltaTime()
    {
	return (PathDeltaTime)mComponents[1];
    }
    
    public void setPathDeltaTime(PathDeltaTime pathDeltaTime)
    {
	mComponents[1] = pathDeltaTime;
    }
    
    public boolean hasPathDeltaTime()
    {
	return componentIsPresent(1);
    }
    
    public void deletePathDeltaTime()
    {
	setComponentAbsent(1);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "PathPoint"
	),
	new QName (
	    "ITS-Container",
	    "PathPoint"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				"DeltaReferencePosition"
			    ),
			    new QName (
				"ITS-Container",
				"DeltaReferencePosition"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				    "DeltaReferencePosition"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				    "DeltaReferencePosition"
				)
			    ),
			    0
			)
		    ),
		    "pathPosition",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				"PathDeltaTime"
			    ),
			    new QName (
				"ITS-Container",
				"PathDeltaTime"
			    ),
			    12318,
			    new ExtensibleConstraint (
				new ValueRangeConstraint (
				    new AbstractBounds(
					new PathDeltaTime(0), 
					new PathDeltaTime(65535),
					0
				    )
				),
				null
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(65535)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"tenMilliSecondsInPast",
					1
				    )
				}
			    )
			)
		    ),
		    "pathDeltaTime",
		    1,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' PathPoint object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' PathPoint object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for PathPoint
