/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type RoadClass from ASN1 Module ITS_Container.
 * @see Enumerated
 */

public final class RoadClass extends Enumerated {
    
    /**
     * The default constructor.
     */
    private RoadClass()
    {
	super(cFirstNumber);
    }
    
    protected RoadClass(long value)
    {
	super(value);
    }
    
    public static final class Value {
	public static final long urban_NoStructuralSeparationToOppositeLanes = 0;
	public static final long urban_WithStructuralSeparationToOppositeLanes = 1;
	public static final long nonUrban_NoStructuralSeparationToOppositeLanes = 2;
	public static final long nonUrban_WithStructuralSeparationToOppositeLanes = 3;
    }
    // Named list definitions.
    public static final RoadClass urban_NoStructuralSeparationToOppositeLanes =
	new RoadClass();
    public static final RoadClass urban_WithStructuralSeparationToOppositeLanes =
	new RoadClass(1);
    public static final RoadClass nonUrban_NoStructuralSeparationToOppositeLanes =
	new RoadClass(2);
    public static final RoadClass nonUrban_WithStructuralSeparationToOppositeLanes =
	new RoadClass(3);
    private final static RoadClass cNamedNumbers[] = {
	 urban_NoStructuralSeparationToOppositeLanes, 
	 urban_WithStructuralSeparationToOppositeLanes, 
	 nonUrban_NoStructuralSeparationToOppositeLanes, 
	 nonUrban_WithStructuralSeparationToOppositeLanes
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public Enumerated[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    public static RoadClass valueOf(long value)
    {
	return (RoadClass)urban_NoStructuralSeparationToOppositeLanes.lookupValue(value);
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
	new Tags (
	    new short[] {
		0x000a
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "RoadClass"
	),
	new QName (
	    "ITS-Container",
	    "RoadClass"
	),
	12314,
	null,
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "urban-NoStructuralSeparationToOppositeLanes",
		    0
		),
		new MemberListElement (
		    "urban-WithStructuralSeparationToOppositeLanes",
		    1
		),
		new MemberListElement (
		    "nonUrban-NoStructuralSeparationToOppositeLanes",
		    2
		),
		new MemberListElement (
		    "nonUrban-WithStructuralSeparationToOppositeLanes",
		    3
		)
	    }
	),
	0,
	urban_NoStructuralSeparationToOppositeLanes
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' RoadClass object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' RoadClass object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for RoadClass
