/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import com.oss.jiaapi.*;

public class JIADENM_PDU_Descriptions {

    public static JIA_Module jia_module = new JIA_Module(
	"DENM-PDU-Descriptions",
	JIA_Module.MODE_TAGGING_AUTOMATIC,
	false,
	new JIA_DefinedTypes(
	    new JIA_DefinedType[] {
		new JIA_DefinedType("SequenceNumber", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.SequenceNumber"),
		new JIA_DefinedType("ActionID", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.ActionID"),
		new JIA_DefinedType("RelevanceDistance", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.RelevanceDistance"),
		new JIA_DefinedType("RelevanceTrafficDirection", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.RelevanceTrafficDirection"),
		new JIA_DefinedType("ValidityDuration", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.ValidityDuration"),
		new JIA_DefinedType("TransmissionInterval", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.TransmissionInterval"),
		new JIA_DefinedType("ManagementContainer", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.ManagementContainer"),
		new JIA_DefinedType("SituationContainer", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.SituationContainer"),
		new JIA_DefinedType("Traces", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.Traces"),
		new JIA_DefinedType("LocationContainer", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.LocationContainer"),
		new JIA_DefinedType("PositionOfPillars", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.PositionOfPillars"),
		new JIA_DefinedType("ImpactReductionContainer", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.ImpactReductionContainer"),
		new JIA_DefinedType("RestrictedTypes", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.RestrictedTypes"),
		new JIA_DefinedType("ItineraryPath", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.ItineraryPath"),
		new JIA_DefinedType("RoadWorksContainerExtended", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.RoadWorksContainerExtended"),
		new JIA_DefinedType("StationaryVehicleContainer", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.StationaryVehicleContainer"),
		new JIA_DefinedType("AlacarteContainer", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.AlacarteContainer"),
		new JIA_DefinedType("DecentralizedEnvironmentalNotificationMessage", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.DecentralizedEnvironmentalNotificationMessage"),
		new JIA_DefinedType("DENM", "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions.DENM")
	    }
	),
	new JIA_ValueReferences(
	    new JIA_ValueReference[] {
		new JIA_ValueReference("defaultValidity", DENM_PDU_Descriptions.defaultValidity)
	    }
	),
	new ObjectIdentifier(
	    new byte[] { 
                (byte)0x04, (byte)0x00, (byte)0x05, (byte)0x01, (byte)0x92, 
                (byte)0xBC, (byte)0x2D, (byte)0x01, (byte)0x01
            }
	)
    );
}
