/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type LocationContainer from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class LocationContainer extends Sequence {
    
    /**
     * The default constructor.
     */
    public LocationContainer()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public LocationContainer(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Speed eventSpeed, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Heading eventPositionHeading, 
		    Traces traces, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.RoadType roadType)
    {
	setEventSpeed(eventSpeed);
	setEventPositionHeading(eventPositionHeading);
	setTraces(traces);
	setRoadType(roadType);
    }
    
    /**
     * Construct with required components.
     */
    public LocationContainer(Traces traces)
    {
	setTraces(traces);
    }
    
    public void initComponents()
    {
	mComponents[0] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Speed();
	mComponents[1] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Heading();
	mComponents[2] = new Traces();
	mComponents[3] = org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.RoadType.urban_NoStructuralSeparationToOppositeLanes;
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[4];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Speed();
	    case 1:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Heading();
	    case 2:
		return new Traces();
	    case 3:
		return org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.RoadType.urban_NoStructuralSeparationToOppositeLanes;
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "eventSpeed"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Speed getEventSpeed()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Speed)mComponents[0];
    }
    
    public void setEventSpeed(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Speed eventSpeed)
    {
	mComponents[0] = eventSpeed;
    }
    
    public boolean hasEventSpeed()
    {
	return componentIsPresent(0);
    }
    
    public void deleteEventSpeed()
    {
	setComponentAbsent(0);
    }
    
    
    // Methods for field "eventPositionHeading"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Heading getEventPositionHeading()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Heading)mComponents[1];
    }
    
    public void setEventPositionHeading(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.Heading eventPositionHeading)
    {
	mComponents[1] = eventPositionHeading;
    }
    
    public boolean hasEventPositionHeading()
    {
	return componentIsPresent(1);
    }
    
    public void deleteEventPositionHeading()
    {
	setComponentAbsent(1);
    }
    
    
    // Methods for field "traces"
    public Traces getTraces()
    {
	return (Traces)mComponents[2];
    }
    
    public void setTraces(Traces traces)
    {
	mComponents[2] = traces;
    }
    
    
    // Methods for field "roadType"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.RoadType getRoadType()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.RoadType)mComponents[3];
    }
    
    public void setRoadType(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.RoadType roadType)
    {
	mComponents[3] = roadType;
    }
    
    public boolean hasRoadType()
    {
	return componentIsPresent(3);
    }
    
    public void deleteRoadType()
    {
	setComponentAbsent(3);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "LocationContainer"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "LocationContainer"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"Speed"
			    ),
			    new QName (
				"ITS-Container",
				"Speed"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "Speed"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "Speed"
				)
			    ),
			    0
			)
		    ),
		    "eventSpeed",
		    0,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"Heading"
			    ),
			    new QName (
				"ITS-Container",
				"Heading"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "Heading"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "Heading"
				)
			    ),
			    0
			)
		    ),
		    "eventPositionHeading",
		    1,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ContainerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Traces"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Traces"
			    ),
			    12314,
			    new SizeConstraint (
				new ValueRangeConstraint (
				    new AbstractBounds(
					new com.oss.asn1.INTEGER(0), 
					new com.oss.asn1.INTEGER(7),
					0
				    )
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(7)
			    ),
			    new TypeInfoRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "PathHistory"
				)
			    )
			)
		    ),
		    "traces",
		    2,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"RoadType"
			    ),
			    new QName (
				"ITS-Container",
				"RoadType"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"urban-NoStructuralSeparationToOppositeLanes",
					0
				    ),
				    new MemberListElement (
					"urban-WithStructuralSeparationToOppositeLanes",
					1
				    ),
				    new MemberListElement (
					"nonUrban-NoStructuralSeparationToOppositeLanes",
					2
				    ),
				    new MemberListElement (
					"nonUrban-WithStructuralSeparationToOppositeLanes",
					3
				    )
				}
			    ),
			    0,
			    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.RoadType.urban_NoStructuralSeparationToOppositeLanes
			)
		    ),
		    "roadType",
		    3,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0),
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' LocationContainer object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' LocationContainer object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for LocationContainer
