/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type RelevanceDistance from ASN1 Module DENM_PDU_Descriptions.
 * @see Enumerated
 */

public final class RelevanceDistance extends Enumerated {
    
    /**
     * The default constructor.
     */
    private RelevanceDistance()
    {
	super(cFirstNumber);
    }
    
    protected RelevanceDistance(long value)
    {
	super(value);
    }
    
    public static final class Value {
	public static final long lessThan50m = 0;
	public static final long lessThan100m = 1;
	public static final long lessThan200m = 2;
	public static final long lessThan500m = 3;
	public static final long lessThan1000m = 4;
	public static final long lessThan5km = 5;
	public static final long lessThan10km = 6;
	public static final long over10km = 7;
    }
    // Named list definitions.
    public static final RelevanceDistance lessThan50m =
	new RelevanceDistance();
    public static final RelevanceDistance lessThan100m =
	new RelevanceDistance(1);
    public static final RelevanceDistance lessThan200m =
	new RelevanceDistance(2);
    public static final RelevanceDistance lessThan500m =
	new RelevanceDistance(3);
    public static final RelevanceDistance lessThan1000m =
	new RelevanceDistance(4);
    public static final RelevanceDistance lessThan5km =
	new RelevanceDistance(5);
    public static final RelevanceDistance lessThan10km =
	new RelevanceDistance(6);
    public static final RelevanceDistance over10km =
	new RelevanceDistance(7);
    private final static RelevanceDistance cNamedNumbers[] = {
	 lessThan50m, 
	 lessThan100m, 
	 lessThan200m, 
	 lessThan500m, 
	 lessThan1000m, 
	 lessThan5km, 
	 lessThan10km, 
	 over10km
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public Enumerated[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    public static RelevanceDistance valueOf(long value)
    {
	return (RelevanceDistance)lessThan50m.lookupValue(value);
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
	new Tags (
	    new short[] {
		0x000a
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "RelevanceDistance"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "RelevanceDistance"
	),
	12314,
	null,
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "lessThan50m",
		    0
		),
		new MemberListElement (
		    "lessThan100m",
		    1
		),
		new MemberListElement (
		    "lessThan200m",
		    2
		),
		new MemberListElement (
		    "lessThan500m",
		    3
		),
		new MemberListElement (
		    "lessThan1000m",
		    4
		),
		new MemberListElement (
		    "lessThan5km",
		    5
		),
		new MemberListElement (
		    "lessThan10km",
		    6
		),
		new MemberListElement (
		    "over10km",
		    7
		)
	    }
	),
	0,
	lessThan50m
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' RelevanceDistance object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' RelevanceDistance object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for RelevanceDistance
