/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type RestrictedTypes from ASN1 Module DENM_PDU_Descriptions.
 * @see SequenceOf
 */

public class RestrictedTypes extends SequenceOf {
    
    /**
     * The default constructor.
     */
    public RestrictedTypes()
    {
    }
    
    /**
     * Construct from an array of components.
     */
    public RestrictedTypes(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType[] elements)
    {
	super(elements);
    }
    
    /**
     * Add an Element to the SEQUENCE OF/SET OF.
     */
    public synchronized void add(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType element)
    {
	super.addElement(element);
    }
    
    /**
     * Set an Element in the SEQUENCE OF/SET OF.
     */
    public synchronized void set(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType element, int atIndex)
    {
	super.setElement(element, atIndex);
    }
    
    /**
     * Get an Element from the SEQUENCE OF/SET OF.
     */
    public synchronized org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType get(int atIndex)
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType)super.getElement(atIndex);
    }
    
    /**
     * Insert an Element into the SEQUENCE OF/SET OF.
     */
    public synchronized void insert(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType element, int atIndex)
    {
	super.insertElement(element, atIndex);
    }
    
    /**
     * Remove an Element from the SEQUENCE OF/SET OF.
     */
    public synchronized void remove(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType element)
    {
	super.removeElement(element);
    }
    
    /**
     * Create an instance of  SEQUENCE OF/SET OF.
     */
    public AbstractData createInstance()
    {
	return (AbstractData)new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType();
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final ContainerInfo c_typeinfo = new ContainerInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "RestrictedTypes"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "RestrictedTypes"
	),
	12314,
	null,
	null,
	new TypeInfoRef (
	    new QName (
		"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
		"StationType"
	    )
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' RestrictedTypes object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' RestrictedTypes object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for RestrictedTypes
