/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type RoadWorksContainerExtended from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class RoadWorksContainerExtended extends Sequence {
    
    /**
     * The default constructor.
     */
    public RoadWorksContainerExtended()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public RoadWorksContainerExtended(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.LightBarSirenInUse lightBarSirenInUse, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.ClosedLanes closedLanes, 
		    RestrictedTypes restriction, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.SpeedLimit speedLimit, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode incidentIndication, 
		    ItineraryPath recommendedPath)
    {
	setLightBarSirenInUse(lightBarSirenInUse);
	setClosedLanes(closedLanes);
	setRestriction(restriction);
	setSpeedLimit(speedLimit);
	setIncidentIndication(incidentIndication);
	setRecommendedPath(recommendedPath);
    }
    
    public void initComponents()
    {
	mComponents[0] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.LightBarSirenInUse();
	mComponents[1] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.ClosedLanes();
	mComponents[2] = new RestrictedTypes();
	mComponents[3] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.SpeedLimit();
	mComponents[4] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode();
	mComponents[5] = new ItineraryPath();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[6];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.LightBarSirenInUse();
	    case 1:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.ClosedLanes();
	    case 2:
		return new RestrictedTypes();
	    case 3:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.SpeedLimit();
	    case 4:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode();
	    case 5:
		return new ItineraryPath();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "lightBarSirenInUse"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.LightBarSirenInUse getLightBarSirenInUse()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.LightBarSirenInUse)mComponents[0];
    }
    
    public void setLightBarSirenInUse(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.LightBarSirenInUse lightBarSirenInUse)
    {
	mComponents[0] = lightBarSirenInUse;
    }
    
    public boolean hasLightBarSirenInUse()
    {
	return componentIsPresent(0);
    }
    
    public void deleteLightBarSirenInUse()
    {
	setComponentAbsent(0);
    }
    
    
    // Methods for field "closedLanes"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.ClosedLanes getClosedLanes()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.ClosedLanes)mComponents[1];
    }
    
    public void setClosedLanes(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.ClosedLanes closedLanes)
    {
	mComponents[1] = closedLanes;
    }
    
    public boolean hasClosedLanes()
    {
	return componentIsPresent(1);
    }
    
    public void deleteClosedLanes()
    {
	setComponentAbsent(1);
    }
    
    
    // Methods for field "restriction"
    public RestrictedTypes getRestriction()
    {
	return (RestrictedTypes)mComponents[2];
    }
    
    public void setRestriction(RestrictedTypes restriction)
    {
	mComponents[2] = restriction;
    }
    
    public boolean hasRestriction()
    {
	return componentIsPresent(2);
    }
    
    public void deleteRestriction()
    {
	setComponentAbsent(2);
    }
    
    
    // Methods for field "speedLimit"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.SpeedLimit getSpeedLimit()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.SpeedLimit)mComponents[3];
    }
    
    public void setSpeedLimit(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.SpeedLimit speedLimit)
    {
	mComponents[3] = speedLimit;
    }
    
    public boolean hasSpeedLimit()
    {
	return componentIsPresent(3);
    }
    
    public void deleteSpeedLimit()
    {
	setComponentAbsent(3);
    }
    
    
    // Methods for field "incidentIndication"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode getIncidentIndication()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode)mComponents[4];
    }
    
    public void setIncidentIndication(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode incidentIndication)
    {
	mComponents[4] = incidentIndication;
    }
    
    public boolean hasIncidentIndication()
    {
	return componentIsPresent(4);
    }
    
    public void deleteIncidentIndication()
    {
	setComponentAbsent(4);
    }
    
    
    // Methods for field "recommendedPath"
    public ItineraryPath getRecommendedPath()
    {
	return (ItineraryPath)mComponents[5];
    }
    
    public void setRecommendedPath(ItineraryPath recommendedPath)
    {
	mComponents[5] = recommendedPath;
    }
    
    public boolean hasRecommendedPath()
    {
	return componentIsPresent(5);
    }
    
    public void deleteRecommendedPath()
    {
	setComponentAbsent(5);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "RoadWorksContainerExtended"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "RoadWorksContainerExtended"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"LightBarSirenInUse"
			    ),
			    new QName (
				"ITS-Container",
				"LightBarSirenInUse"
			    ),
			    12314,
			    new SizeConstraint (
				new SingleValueConstraint (
				    new com.oss.asn1.INTEGER(2)
				)
			    ),
			    new Bounds (
				new java.lang.Long(2),
				new java.lang.Long(2)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"lightBarActivated",
					0
				    ),
				    new MemberListElement (
					"sirenActivated",
					1
				    )
				}
			    )
			)
		    ),
		    "lightBarSirenInUse",
		    0,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"ClosedLanes"
			    ),
			    new QName (
				"ITS-Container",
				"ClosedLanes"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "ClosedLanes"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "ClosedLanes"
				)
			    ),
			    0
			)
		    ),
		    "closedLanes",
		    1,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ContainerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"RestrictedTypes"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"RestrictedTypes"
			    ),
			    12314,
			    null,
			    null,
			    new TypeInfoRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "StationType"
				)
			    )
			)
		    ),
		    "restriction",
		    2,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"SpeedLimit"
			    ),
			    new QName (
				"ITS-Container",
				"SpeedLimit"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.SpeedLimit(0), 
				    new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.SpeedLimit(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneKmPerHour",
					1
				    )
				}
			    )
			)
		    ),
		    "speedLimit",
		    3,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8004
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"CauseCode"
			    ),
			    new QName (
				"ITS-Container",
				"CauseCode"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "CauseCode"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "CauseCode"
				)
			    ),
			    0
			)
		    ),
		    "incidentIndication",
		    4,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ContainerInfo (
			    new Tags (
				new short[] {
				    (short)0x8005
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"ItineraryPath"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"ItineraryPath"
			    ),
			    12314,
			    new SizeConstraint (
				new ValueRangeConstraint (
				    new AbstractBounds(
					new com.oss.asn1.INTEGER(0), 
					new com.oss.asn1.INTEGER(40),
					0
				    )
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(40)
			    ),
			    new TypeInfoRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "ReferencePosition"
				)
			    )
			)
		    ),
		    "recommendedPath",
		    5,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0),
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8005, 5)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' RoadWorksContainerExtended object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' RoadWorksContainerExtended object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for RoadWorksContainerExtended
