/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type SituationContainer from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class SituationContainer extends Sequence {
    
    /**
     * The default constructor.
     */
    public SituationContainer()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public SituationContainer(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.InformationQuality informationQuality, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode eventType, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode linkedCause)
    {
	setInformationQuality(informationQuality);
	setEventType(eventType);
	setLinkedCause(linkedCause);
    }
    
    /**
     * Construct with required components.
     */
    public SituationContainer(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.InformationQuality informationQuality, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode eventType)
    {
	setInformationQuality(informationQuality);
	setEventType(eventType);
    }
    
    public void initComponents()
    {
	mComponents[0] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.InformationQuality();
	mComponents[1] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode();
	mComponents[2] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[3];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.InformationQuality();
	    case 1:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode();
	    case 2:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "informationQuality"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.InformationQuality getInformationQuality()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.InformationQuality)mComponents[0];
    }
    
    public void setInformationQuality(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.InformationQuality informationQuality)
    {
	mComponents[0] = informationQuality;
    }
    
    
    // Methods for field "eventType"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode getEventType()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode)mComponents[1];
    }
    
    public void setEventType(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode eventType)
    {
	mComponents[1] = eventType;
    }
    
    
    // Methods for field "linkedCause"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode getLinkedCause()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode)mComponents[2];
    }
    
    public void setLinkedCause(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode linkedCause)
    {
	mComponents[2] = linkedCause;
    }
    
    public boolean hasLinkedCause()
    {
	return componentIsPresent(2);
    }
    
    public void deleteLinkedCause()
    {
	setComponentAbsent(2);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "SituationContainer"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "SituationContainer"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"InformationQuality"
			    ),
			    new QName (
				"ITS-Container",
				"InformationQuality"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.InformationQuality(0), 
				    new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.InformationQuality(7),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(7)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"unavailable",
					0
				    ),
				    new MemberListElement (
					"lowest",
					1
				    ),
				    new MemberListElement (
					"highest",
					7
				    )
				}
			    )
			)
		    ),
		    "informationQuality",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"CauseCode"
			    ),
			    new QName (
				"ITS-Container",
				"CauseCode"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "CauseCode"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "CauseCode"
				)
			    ),
			    0
			)
		    ),
		    "eventType",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"CauseCode"
			    ),
			    new QName (
				"ITS-Container",
				"CauseCode"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "CauseCode"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "CauseCode"
				)
			    ),
			    0
			)
		    ),
		    "linkedCause",
		    2,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' SituationContainer object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' SituationContainer object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for SituationContainer
