/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type RescueContainer from ASN1 Module CAM_PDU_Descriptions.
 * @see Sequence
 */

public class RescueContainer extends Sequence {
    
    /**
     * The default constructor.
     */
    public RescueContainer()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public RescueContainer(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse lightBarSirenInUse, 
		    org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmergencyPriority emergencyPriority)
    {
	setLightBarSirenInUse(lightBarSirenInUse);
	setEmergencyPriority(emergencyPriority);
    }
    
    /**
     * Construct with required components.
     */
    public RescueContainer(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse lightBarSirenInUse)
    {
	setLightBarSirenInUse(lightBarSirenInUse);
    }
    
    public void initComponents()
    {
	mComponents[0] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse();
	mComponents[1] = new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmergencyPriority();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse();
	    case 1:
		return new org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmergencyPriority();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "lightBarSirenInUse"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse getLightBarSirenInUse()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse)mComponents[0];
    }
    
    public void setLightBarSirenInUse(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse lightBarSirenInUse)
    {
	mComponents[0] = lightBarSirenInUse;
    }
    
    
    // Methods for field "emergencyPriority"
    public org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmergencyPriority getEmergencyPriority()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmergencyPriority)mComponents[1];
    }
    
    public void setEmergencyPriority(org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmergencyPriority emergencyPriority)
    {
	mComponents[1] = emergencyPriority;
    }
    
    public boolean hasEmergencyPriority()
    {
	return componentIsPresent(1);
    }
    
    public void deleteEmergencyPriority()
    {
	setComponentAbsent(1);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
	    "RescueContainer"
	),
	new QName (
	    "CAM-PDU-Descriptions",
	    "RescueContainer"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"LightBarSirenInUse"
			    ),
			    new QName (
				"ITS-Container",
				"LightBarSirenInUse"
			    ),
			    12314,
			    new SizeConstraint (
				new SingleValueConstraint (
				    new com.oss.asn1.INTEGER(2)
				)
			    ),
			    new Bounds (
				new java.lang.Long(2),
				new java.lang.Long(2)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"lightBarActivated",
					0
				    ),
				    new MemberListElement (
					"sirenActivated",
					1
				    )
				}
			    )
			)
		    ),
		    "lightBarSirenInUse",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"EmergencyPriority"
			    ),
			    new QName (
				"ITS-Container",
				"EmergencyPriority"
			    ),
			    12314,
			    new SizeConstraint (
				new SingleValueConstraint (
				    new com.oss.asn1.INTEGER(2)
				)
			    ),
			    new Bounds (
				new java.lang.Long(2),
				new java.lang.Long(2)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"requestForRightOfWay",
					0
				    ),
				    new MemberListElement (
					"requestForFreeCrossingAtATrafficLight",
					1
				    )
				}
			    )
			)
		    ),
		    "emergencyPriority",
		    1,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' RescueContainer object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' RescueContainer object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for RescueContainer
