/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type AccidentSubCauseCode from ASN1 Module ITS_Container.
 * @see INTEGER
 */

public class AccidentSubCauseCode extends INTEGER {
    
    /**
     * The default constructor.
     */
    public AccidentSubCauseCode()
    {
    }
    
    public AccidentSubCauseCode(short value)
    {
	super(value);
    }
    
    public AccidentSubCauseCode(int value)
    {
	super(value);
    }
    
    public AccidentSubCauseCode(long value)
    {
	super(value);
    }
    
    // Named list definitions.
    public static final AccidentSubCauseCode unavailable =
	new AccidentSubCauseCode(0);
    public static final AccidentSubCauseCode multiVehicleAccident =
	new AccidentSubCauseCode(1);
    public static final AccidentSubCauseCode heavyAccident =
	new AccidentSubCauseCode(2);
    public static final AccidentSubCauseCode accidentInvolvingLorry =
	new AccidentSubCauseCode(3);
    public static final AccidentSubCauseCode accidentInvolvingBus =
	new AccidentSubCauseCode(4);
    public static final AccidentSubCauseCode accidentInvolvingHazardousMaterials =
	new AccidentSubCauseCode(5);
    public static final AccidentSubCauseCode accidentOnOppositeLane =
	new AccidentSubCauseCode(6);
    public static final AccidentSubCauseCode unsecuredAccident =
	new AccidentSubCauseCode(7);
    public static final AccidentSubCauseCode assistanceRequested =
	new AccidentSubCauseCode(8);
    private final static AccidentSubCauseCode cNamedNumbers[] = {
	 unavailable, 
	 multiVehicleAccident, 
	 heavyAccident, 
	 accidentInvolvingLorry, 
	 accidentInvolvingBus, 
	 accidentInvolvingHazardousMaterials, 
	 accidentOnOppositeLane, 
	 unsecuredAccident, 
	 assistanceRequested
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public INTEGER[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final IntegerInfo c_typeinfo = new IntegerInfo (
	new Tags (
	    new short[] {
		0x0002
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
	    "AccidentSubCauseCode"
	),
	new QName (
	    "ITS-Container",
	    "AccidentSubCauseCode"
	),
	12314,
	new ValueRangeConstraint (
	    new AbstractBounds(
		new AccidentSubCauseCode(0), 
		new AccidentSubCauseCode(255),
		0
	    )
	),
	new Bounds (
	    new java.lang.Long(0),
	    new java.lang.Long(255)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "unavailable",
		    0
		),
		new MemberListElement (
		    "multiVehicleAccident",
		    1
		),
		new MemberListElement (
		    "heavyAccident",
		    2
		),
		new MemberListElement (
		    "accidentInvolvingLorry",
		    3
		),
		new MemberListElement (
		    "accidentInvolvingBus",
		    4
		),
		new MemberListElement (
		    "accidentInvolvingHazardousMaterials",
		    5
		),
		new MemberListElement (
		    "accidentOnOppositeLane",
		    6
		),
		new MemberListElement (
		    "unsecuredAccident",
		    7
		),
		new MemberListElement (
		    "assistanceRequested",
		    8
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' AccidentSubCauseCode object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' AccidentSubCauseCode object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for AccidentSubCauseCode
