/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;
import com.oss.jiaapi.*;

public class JIAITS_Container {

    public static JIA_Module jia_module = new JIA_Module(
	"ITS-Container",
	JIA_Module.MODE_TAGGING_AUTOMATIC,
	false,
	new JIA_DefinedTypes(
	    new JIA_DefinedType[] {
		new JIA_DefinedType("StationID", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.StationID"),
		new JIA_DefinedType("ItsPduHeader", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ItsPduHeader"),
		new JIA_DefinedType("Latitude", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.Latitude"),
		new JIA_DefinedType("Longitude", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.Longitude"),
		new JIA_DefinedType("SemiAxisLength", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SemiAxisLength"),
		new JIA_DefinedType("HeadingValue", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.HeadingValue"),
		new JIA_DefinedType("HeadingConfidence", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.HeadingConfidence"),
		new JIA_DefinedType("Heading", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.Heading"),
		new JIA_DefinedType("PosConfidenceEllipse", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PosConfidenceEllipse"),
		new JIA_DefinedType("AltitudeValue", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.AltitudeValue"),
		new JIA_DefinedType("AltitudeConfidence", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.AltitudeConfidence"),
		new JIA_DefinedType("Altitude", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.Altitude"),
		new JIA_DefinedType("ReferencePosition", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ReferencePosition"),
		new JIA_DefinedType("DeltaLatitude", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.DeltaLatitude"),
		new JIA_DefinedType("DeltaLongitude", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.DeltaLongitude"),
		new JIA_DefinedType("DeltaAltitude", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.DeltaAltitude"),
		new JIA_DefinedType("DeltaReferencePosition", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.DeltaReferencePosition"),
		new JIA_DefinedType("PathDeltaTime", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PathDeltaTime"),
		new JIA_DefinedType("PathPoint", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PathPoint"),
		new JIA_DefinedType("PtActivationType", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PtActivationType"),
		new JIA_DefinedType("PtActivationData", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PtActivationData"),
		new JIA_DefinedType("PtActivation", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PtActivation"),
		new JIA_DefinedType("AccelerationControl", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.AccelerationControl"),
		new JIA_DefinedType("CauseCodeType", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CauseCodeType"),
		new JIA_DefinedType("SubCauseCodeType", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SubCauseCodeType"),
		new JIA_DefinedType("CauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CauseCode"),
		new JIA_DefinedType("TrafficConditionSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TrafficConditionSubCauseCode"),
		new JIA_DefinedType("AccidentSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.AccidentSubCauseCode"),
		new JIA_DefinedType("RoadworksSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RoadworksSubCauseCode"),
		new JIA_DefinedType("HumanPresenceOnTheRoadSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.HumanPresenceOnTheRoadSubCauseCode"),
		new JIA_DefinedType("WrongWayDrivingSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.WrongWayDrivingSubCauseCode"),
		new JIA_DefinedType("AdverseWeatherCondition-ExtremeWeatherConditionSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode"),
		new JIA_DefinedType("AdverseWeatherCondition-AdhesionSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.AdverseWeatherCondition_AdhesionSubCauseCode"),
		new JIA_DefinedType("AdverseWeatherCondition-VisibilitySubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.AdverseWeatherCondition_VisibilitySubCauseCode"),
		new JIA_DefinedType("AdverseWeatherCondition-PrecipitationSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.AdverseWeatherCondition_PrecipitationSubCauseCode"),
		new JIA_DefinedType("SlowVehicleSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SlowVehicleSubCauseCode"),
		new JIA_DefinedType("StationaryVehicleSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.StationaryVehicleSubCauseCode"),
		new JIA_DefinedType("HumanProblemSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.HumanProblemSubCauseCode"),
		new JIA_DefinedType("EmergencyVehicleApproachingSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmergencyVehicleApproachingSubCauseCode"),
		new JIA_DefinedType("HazardousLocation-DangerousCurveSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.HazardousLocation_DangerousCurveSubCauseCode"),
		new JIA_DefinedType("HazardousLocation-SurfaceConditionSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.HazardousLocation_SurfaceConditionSubCauseCode"),
		new JIA_DefinedType("HazardousLocation-ObstacleOnTheRoadSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.HazardousLocation_ObstacleOnTheRoadSubCauseCode"),
		new JIA_DefinedType("HazardousLocation-AnimalOnTheRoadSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.HazardousLocation_AnimalOnTheRoadSubCauseCode"),
		new JIA_DefinedType("CollisionRiskSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CollisionRiskSubCauseCode"),
		new JIA_DefinedType("SignalViolationSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SignalViolationSubCauseCode"),
		new JIA_DefinedType("RescueAndRecoveryWorkInProgressSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RescueAndRecoveryWorkInProgressSubCauseCode"),
		new JIA_DefinedType("DangerousEndOfQueueSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.DangerousEndOfQueueSubCauseCode"),
		new JIA_DefinedType("DangerousSituationSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.DangerousSituationSubCauseCode"),
		new JIA_DefinedType("VehicleBreakdownSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleBreakdownSubCauseCode"),
		new JIA_DefinedType("PostCrashSubCauseCode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PostCrashSubCauseCode"),
		new JIA_DefinedType("CurvatureValue", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CurvatureValue"),
		new JIA_DefinedType("CurvatureConfidence", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CurvatureConfidence"),
		new JIA_DefinedType("Curvature", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.Curvature"),
		new JIA_DefinedType("CurvatureCalculationMode", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.CurvatureCalculationMode"),
		new JIA_DefinedType("LaneNumber", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LaneNumber"),
		new JIA_DefinedType("HardShoulderStatus", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.HardShoulderStatus"),
		new JIA_DefinedType("DrivingLaneStatus", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.DrivingLaneStatus"),
		new JIA_DefinedType("ClosedLanes", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ClosedLanes"),
		new JIA_DefinedType("PerformanceClass", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PerformanceClass"),
		new JIA_DefinedType("SpeedValue", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedValue"),
		new JIA_DefinedType("SpeedConfidence", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedConfidence"),
		new JIA_DefinedType("VehicleMass", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleMass"),
		new JIA_DefinedType("Speed", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.Speed"),
		new JIA_DefinedType("DriveDirection", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.DriveDirection"),
		new JIA_DefinedType("EmbarkationStatus", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmbarkationStatus"),
		new JIA_DefinedType("LongitudinalAccelerationValue", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LongitudinalAccelerationValue"),
		new JIA_DefinedType("AccelerationConfidence", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.AccelerationConfidence"),
		new JIA_DefinedType("LongitudinalAcceleration", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LongitudinalAcceleration"),
		new JIA_DefinedType("LateralAccelerationValue", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LateralAccelerationValue"),
		new JIA_DefinedType("LateralAcceleration", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LateralAcceleration"),
		new JIA_DefinedType("VerticalAccelerationValue", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VerticalAccelerationValue"),
		new JIA_DefinedType("VerticalAcceleration", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VerticalAcceleration"),
		new JIA_DefinedType("StationType", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.StationType"),
		new JIA_DefinedType("ExteriorLights", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.ExteriorLights"),
		new JIA_DefinedType("DangerousGoodsBasic", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.DangerousGoodsBasic"),
		new JIA_DefinedType("DangerousGoodsExtended", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.DangerousGoodsExtended"),
		new JIA_DefinedType("SpecialTransportType", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpecialTransportType"),
		new JIA_DefinedType("LightBarSirenInUse", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.LightBarSirenInUse"),
		new JIA_DefinedType("HeightLonCarr", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.HeightLonCarr"),
		new JIA_DefinedType("PosLonCarr", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PosLonCarr"),
		new JIA_DefinedType("PosPillar", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PosPillar"),
		new JIA_DefinedType("PosCentMass", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PosCentMass"),
		new JIA_DefinedType("RequestResponseIndication", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RequestResponseIndication"),
		new JIA_DefinedType("SpeedLimit", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SpeedLimit"),
		new JIA_DefinedType("StationarySince", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.StationarySince"),
		new JIA_DefinedType("Temperature", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.Temperature"),
		new JIA_DefinedType("TrafficRule", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TrafficRule"),
		new JIA_DefinedType("WheelBaseVehicle", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.WheelBaseVehicle"),
		new JIA_DefinedType("TurningRadius", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TurningRadius"),
		new JIA_DefinedType("PosFrontAx", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PosFrontAx"),
		new JIA_DefinedType("PositionOfOccupants", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PositionOfOccupants"),
		new JIA_DefinedType("PositioningSolutionType", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PositioningSolutionType"),
		new JIA_DefinedType("WMInumber", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.WMInumber"),
		new JIA_DefinedType("VDS", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VDS"),
		new JIA_DefinedType("VehicleIdentification", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleIdentification"),
		new JIA_DefinedType("EnergyStorageType", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EnergyStorageType"),
		new JIA_DefinedType("VehicleLengthValue", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleLengthValue"),
		new JIA_DefinedType("VehicleLengthConfidenceIndication", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleLengthConfidenceIndication"),
		new JIA_DefinedType("VehicleLength", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleLength"),
		new JIA_DefinedType("VehicleWidth", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleWidth"),
		new JIA_DefinedType("PathHistory", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.PathHistory"),
		new JIA_DefinedType("EmergencyPriority", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.EmergencyPriority"),
		new JIA_DefinedType("InformationQuality", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.InformationQuality"),
		new JIA_DefinedType("RoadType", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.RoadType"),
		new JIA_DefinedType("SteeringWheelAngleValue", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SteeringWheelAngleValue"),
		new JIA_DefinedType("SteeringWheelConfidence", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SteeringWheelConfidence"),
		new JIA_DefinedType("SteeringWheelAngle", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.SteeringWheelAngle"),
		new JIA_DefinedType("TimestampIts", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.TimestampIts"),
		new JIA_DefinedType("VehicleRole", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.VehicleRole"),
		new JIA_DefinedType("YawRateValue", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.YawRateValue"),
		new JIA_DefinedType("YawRateConfidence", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.YawRateConfidence"),
		new JIA_DefinedType("YawRate", "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container.YawRate")
	    }
	),
	new JIA_ValueReferences(
	    new JIA_ValueReference[] {
	    }
	),
	new ObjectIdentifier(
	    new byte[] { 
                (byte)0x04, (byte)0x00, (byte)0x05, (byte)0x01, (byte)0x86, 
                (byte)0xA3, (byte)0x6E, (byte)0x02, (byte)0x01
            }
	)
    );
}
