/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type PosConfidenceEllipse from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class PosConfidenceEllipse extends Sequence {
    
    /**
     * The default constructor.
     */
    public PosConfidenceEllipse()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public PosConfidenceEllipse(SemiAxisLength semiMajorConfidence, 
		    SemiAxisLength semiMinorConfidence, 
		    Heading semiMajorOrientation)
    {
	setSemiMajorConfidence(semiMajorConfidence);
	setSemiMinorConfidence(semiMinorConfidence);
	setSemiMajorOrientation(semiMajorOrientation);
    }
    
    public void initComponents()
    {
	mComponents[0] = new SemiAxisLength();
	mComponents[1] = new SemiAxisLength();
	mComponents[2] = new Heading();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[3];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new SemiAxisLength();
	    case 1:
		return new SemiAxisLength();
	    case 2:
		return new Heading();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "semiMajorConfidence"
    public SemiAxisLength getSemiMajorConfidence()
    {
	return (SemiAxisLength)mComponents[0];
    }
    
    public void setSemiMajorConfidence(SemiAxisLength semiMajorConfidence)
    {
	mComponents[0] = semiMajorConfidence;
    }
    
    
    // Methods for field "semiMinorConfidence"
    public SemiAxisLength getSemiMinorConfidence()
    {
	return (SemiAxisLength)mComponents[1];
    }
    
    public void setSemiMinorConfidence(SemiAxisLength semiMinorConfidence)
    {
	mComponents[1] = semiMinorConfidence;
    }
    
    
    // Methods for field "semiMajorOrientation"
    public Heading getSemiMajorOrientation()
    {
	return (Heading)mComponents[2];
    }
    
    public void setSemiMajorOrientation(Heading semiMajorOrientation)
    {
	mComponents[2] = semiMajorOrientation;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
	    "PosConfidenceEllipse"
	),
	new QName (
	    "ITS-Container",
	    "PosConfidenceEllipse"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"SemiAxisLength"
			    ),
			    new QName (
				"ITS-Container",
				"SemiAxisLength"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new SemiAxisLength(0), 
				    new SemiAxisLength(4095),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(4095)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneCentimeter",
					1
				    ),
				    new MemberListElement (
					"outOfRange",
					4094
				    ),
				    new MemberListElement (
					"unavailable",
					4095
				    )
				}
			    )
			)
		    ),
		    "semiMajorConfidence",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"SemiAxisLength"
			    ),
			    new QName (
				"ITS-Container",
				"SemiAxisLength"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new SemiAxisLength(0), 
				    new SemiAxisLength(4095),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(4095)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"oneCentimeter",
					1
				    ),
				    new MemberListElement (
					"outOfRange",
					4094
				    ),
				    new MemberListElement (
					"unavailable",
					4095
				    )
				}
			    )
			)
		    ),
		    "semiMinorConfidence",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"Heading"
			    ),
			    new QName (
				"ITS-Container",
				"Heading"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "Heading"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				    "Heading"
				)
			    ),
			    0
			)
		    ),
		    "semiMajorOrientation",
		    2,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' PosConfidenceEllipse object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' PosConfidenceEllipse object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for PosConfidenceEllipse
