/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type Speed from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class Speed extends Sequence {
    
    /**
     * The default constructor.
     */
    public Speed()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public Speed(SpeedValue speedValue, SpeedConfidence speedConfidence)
    {
	setSpeedValue(speedValue);
	setSpeedConfidence(speedConfidence);
    }
    
    public void initComponents()
    {
	mComponents[0] = new SpeedValue();
	mComponents[1] = new SpeedConfidence();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new SpeedValue();
	    case 1:
		return new SpeedConfidence();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "speedValue"
    public SpeedValue getSpeedValue()
    {
	return (SpeedValue)mComponents[0];
    }
    
    public void setSpeedValue(SpeedValue speedValue)
    {
	mComponents[0] = speedValue;
    }
    
    
    // Methods for field "speedConfidence"
    public SpeedConfidence getSpeedConfidence()
    {
	return (SpeedConfidence)mComponents[1];
    }
    
    public void setSpeedConfidence(SpeedConfidence speedConfidence)
    {
	mComponents[1] = speedConfidence;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
	    "Speed"
	),
	new QName (
	    "ITS-Container",
	    "Speed"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"SpeedValue"
			    ),
			    new QName (
				"ITS-Container",
				"SpeedValue"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new SpeedValue(0), 
				    new SpeedValue(16383),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(16383)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"standstill",
					0
				    ),
				    new MemberListElement (
					"oneCentimeterPerSec",
					1
				    ),
				    new MemberListElement (
					"unavailable",
					16383
				    )
				}
			    )
			)
		    ),
		    "speedValue",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
				"SpeedConfidence"
			    ),
			    new QName (
				"ITS-Container",
				"SpeedConfidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new SpeedConfidence(1), 
				    new SpeedConfidence(127),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(1),
				new java.lang.Long(127)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"withinOneCentimeterPerSec",
					1
				    ),
				    new MemberListElement (
					"withinOneMeterPerSec",
					100
				    ),
				    new MemberListElement (
					"outOfRange",
					126
				    ),
				    new MemberListElement (
					"unavailable",
					127
				    )
				}
			    )
			)
		    ),
		    "speedConfidence",
		    1,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' Speed object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' Speed object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for Speed
