/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type StationarySince from ASN1 Module ITS_Container.
 * @see Enumerated
 */

public final class StationarySince extends Enumerated {
    
    /**
     * The default constructor.
     */
    private StationarySince()
    {
	super(cFirstNumber);
    }
    
    protected StationarySince(long value)
    {
	super(value);
    }
    
    public static final class Value {
	public static final long lessThan1Minute = 0;
	public static final long lessThan2Minutes = 1;
	public static final long lessThan15Minutes = 2;
	public static final long over15Minutes = 3;
    }
    // Named list definitions.
    public static final StationarySince lessThan1Minute =
	new StationarySince();
    public static final StationarySince lessThan2Minutes =
	new StationarySince(1);
    public static final StationarySince lessThan15Minutes =
	new StationarySince(2);
    public static final StationarySince over15Minutes =
	new StationarySince(3);
    private final static StationarySince cNamedNumbers[] = {
	 lessThan1Minute, 
	 lessThan2Minutes, 
	 lessThan15Minutes, 
	 over15Minutes
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public Enumerated[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    public static StationarySince valueOf(long value)
    {
	return (StationarySince)lessThan1Minute.lookupValue(value);
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
	new Tags (
	    new short[] {
		0x000a
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
	    "StationarySince"
	),
	new QName (
	    "ITS-Container",
	    "StationarySince"
	),
	12314,
	null,
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "lessThan1Minute",
		    0
		),
		new MemberListElement (
		    "lessThan2Minutes",
		    1
		),
		new MemberListElement (
		    "lessThan15Minutes",
		    2
		),
		new MemberListElement (
		    "over15Minutes",
		    3
		)
	    }
	),
	0,
	lessThan1Minute
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' StationarySince object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' StationarySince object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for StationarySince
