/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Mon Oct 28 13:51:56 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss761139927814299605gen/LibItsCam_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../a7a5305360355393378280d1c5a7c1e7/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type SteeringWheelConfidence from ASN1 Module ITS_Container.
 * @see INTEGER
 */

public class SteeringWheelConfidence extends INTEGER {
    
    /**
     * The default constructor.
     */
    public SteeringWheelConfidence()
    {
    }
    
    public SteeringWheelConfidence(short value)
    {
	super(value);
    }
    
    public SteeringWheelConfidence(int value)
    {
	super(value);
    }
    
    public SteeringWheelConfidence(long value)
    {
	super(value);
    }
    
    // Named list definitions.
    public static final SteeringWheelConfidence withinOnePointFiveDegrees =
	new SteeringWheelConfidence(1);
    public static final SteeringWheelConfidence outOfRange =
	new SteeringWheelConfidence(126);
    public static final SteeringWheelConfidence unavailable =
	new SteeringWheelConfidence(127);
    private final static SteeringWheelConfidence cNamedNumbers[] = {
	 withinOnePointFiveDegrees, 
	 outOfRange, 
	 unavailable
    };
    protected final static long cFirstNumber = 1;
    protected final static boolean cLinearNumbers = false;
    
    public INTEGER[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final IntegerInfo c_typeinfo = new IntegerInfo (
	new Tags (
	    new short[] {
		0x0002
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.its_container",
	    "SteeringWheelConfidence"
	),
	new QName (
	    "ITS-Container",
	    "SteeringWheelConfidence"
	),
	12314,
	new ValueRangeConstraint (
	    new AbstractBounds(
		new SteeringWheelConfidence(1), 
		new SteeringWheelConfidence(127),
		0
	    )
	),
	new Bounds (
	    new java.lang.Long(1),
	    new java.lang.Long(127)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "withinOnePointFiveDegrees",
		    1
		),
		new MemberListElement (
		    "outOfRange",
		    126
		),
		new MemberListElement (
		    "unavailable",
		    127
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' SteeringWheelConfidence object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' SteeringWheelConfidence object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for SteeringWheelConfidence
