/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type Elevation from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class Elevation extends Sequence {
    
    /**
     * The default constructor.
     */
    public Elevation()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public Elevation(ElevationValue elevationValue, 
		    ElevationConfidence elevationConfidence)
    {
	setElevationValue(elevationValue);
	setElevationConfidence(elevationConfidence);
    }
    
    public void initComponents()
    {
	mComponents[0] = new ElevationValue();
	mComponents[1] = new ElevationConfidence();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new ElevationValue();
	    case 1:
		return new ElevationConfidence();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "elevationValue"
    public ElevationValue getElevationValue()
    {
	return (ElevationValue)mComponents[0];
    }
    
    public void setElevationValue(ElevationValue elevationValue)
    {
	mComponents[0] = elevationValue;
    }
    
    
    // Methods for field "elevationConfidence"
    public ElevationConfidence getElevationConfidence()
    {
	return (ElevationConfidence)mComponents[1];
    }
    
    public void setElevationConfidence(ElevationConfidence elevationConfidence)
    {
	mComponents[1] = elevationConfidence;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "Elevation"
	),
	new QName (
	    "ITS-Container",
	    "Elevation"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				"ElevationValue"
			    ),
			    new QName (
				"ITS-Container",
				"ElevationValue"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new ElevationValue(-1000), 
				    new ElevationValue(7191),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-1000),
				new java.lang.Long(7191)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"seaLevel",
					0
				    ),
				    new MemberListElement (
					"oneMeter",
					1
				    ),
				    new MemberListElement (
					"unavailable",
					7191
				    )
				}
			    )
			)
		    ),
		    "elevationValue",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				"ElevationConfidence"
			    ),
			    new QName (
				"ITS-Container",
				"ElevationConfidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new ElevationConfidence(1), 
				    new ElevationConfidence(127),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(1),
				new java.lang.Long(127)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"withinOneMeter",
					1
				    ),
				    new MemberListElement (
					"outOfRange",
					126
				    ),
				    new MemberListElement (
					"unavailable",
					127
				    )
				}
			    )
			)
		    ),
		    "elevationConfidence",
		    1,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' Elevation object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' Elevation object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for Elevation
