/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type EmergencyPriority from ASN1 Module ITS_Container.
 * @see INTEGER
 */

public class EmergencyPriority extends INTEGER {
    
    /**
     * The default constructor.
     */
    public EmergencyPriority()
    {
    }
    
    public EmergencyPriority(short value)
    {
	super(value);
    }
    
    public EmergencyPriority(int value)
    {
	super(value);
    }
    
    public EmergencyPriority(long value)
    {
	super(value);
    }
    
    // Named list definitions.
    public static final EmergencyPriority requestForRightOfWay =
	new EmergencyPriority(0);
    public static final EmergencyPriority requestForFreeCrossingAtATrafficLight =
	new EmergencyPriority(1);
    private final static EmergencyPriority cNamedNumbers[] = {
	 requestForRightOfWay, 
	 requestForFreeCrossingAtATrafficLight
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public INTEGER[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final IntegerInfo c_typeinfo = new IntegerInfo (
	new Tags (
	    new short[] {
		0x0002
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "EmergencyPriority"
	),
	new QName (
	    "ITS-Container",
	    "EmergencyPriority"
	),
	12314,
	new ValueRangeConstraint (
	    new AbstractBounds(
		new EmergencyPriority(0), 
		new EmergencyPriority(1),
		0
	    )
	),
	new Bounds (
	    new java.lang.Long(0),
	    new java.lang.Long(1)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "requestForRightOfWay",
		    0
		),
		new MemberListElement (
		    "requestForFreeCrossingAtATrafficLight",
		    1
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' EmergencyPriority object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' EmergencyPriority object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for EmergencyPriority
