/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type ExteriorLights from ASN1 Module ITS_Container.
 * @see BitString
 */

public class ExteriorLights extends BitString {
    
    /**
     * The default constructor.
     */
    public ExteriorLights()
    {
    }
    
    /**
     * Construct Bit String from a byte array.
     * All bits considered significant.
     * @param value the byte array to set this object to.
     */
    public ExteriorLights(byte[] value)
    {
	super(value);
    }
    
    
    /**
     * Construct Bit String from a byte array and significant bits.
     * @param value the byte array to set this object to.
     * @param sigBits the number of significant bits.
     */
    public ExteriorLights(byte[] value, int sigBits)
    {
	super(value, sigBits);
    }
    
    // Named list definitions.
    public static final int lowBeamHeadlightsOn = 0;
    public static final int highBeamHeadlightsOn = 1;
    public static final int leftTurnSignalOn = 2;
    public static final int rightTurnSignalOn = 3;
    public static final int daytimeRunningLightsOn = 4;
    public static final int reverseLightOn = 5;
    public static final int fogLightOn = 6;
    public static final int parkingLightsOn = 7;
    
    /**
     * Initialize the type descriptor.
     */
    private static final BitStringInfo c_typeinfo = new BitStringInfo (
	new Tags (
	    new short[] {
		0x0003
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "ExteriorLights"
	),
	new QName (
	    "ITS-Container",
	    "ExteriorLights"
	),
	12314,
	new SizeConstraint (
	    new SingleValueConstraint (
		new com.oss.asn1.INTEGER(8)
	    )
	),
	new Bounds (
	    new java.lang.Long(8),
	    new java.lang.Long(8)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "lowBeamHeadlightsOn",
		    0
		),
		new MemberListElement (
		    "highBeamHeadlightsOn",
		    1
		),
		new MemberListElement (
		    "leftTurnSignalOn",
		    2
		),
		new MemberListElement (
		    "rightTurnSignalOn",
		    3
		),
		new MemberListElement (
		    "daytimeRunningLightsOn",
		    4
		),
		new MemberListElement (
		    "reverseLightOn",
		    5
		),
		new MemberListElement (
		    "fogLightOn",
		    6
		),
		new MemberListElement (
		    "parkingLightsOn",
		    7
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' ExteriorLights object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' ExteriorLights object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for ExteriorLights
