/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type LongitudinalAcceleration from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class LongitudinalAcceleration extends Sequence {
    
    /**
     * The default constructor.
     */
    public LongitudinalAcceleration()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public LongitudinalAcceleration(LongitudinalAccelerationValue longitudinalAccelerationValue, 
		    AccelerationConfidence longitudinalAccelerationConfidence)
    {
	setLongitudinalAccelerationValue(longitudinalAccelerationValue);
	setLongitudinalAccelerationConfidence(longitudinalAccelerationConfidence);
    }
    
    public void initComponents()
    {
	mComponents[0] = new LongitudinalAccelerationValue();
	mComponents[1] = new AccelerationConfidence();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new LongitudinalAccelerationValue();
	    case 1:
		return new AccelerationConfidence();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "longitudinalAccelerationValue"
    public LongitudinalAccelerationValue getLongitudinalAccelerationValue()
    {
	return (LongitudinalAccelerationValue)mComponents[0];
    }
    
    public void setLongitudinalAccelerationValue(LongitudinalAccelerationValue longitudinalAccelerationValue)
    {
	mComponents[0] = longitudinalAccelerationValue;
    }
    
    
    // Methods for field "longitudinalAccelerationConfidence"
    public AccelerationConfidence getLongitudinalAccelerationConfidence()
    {
	return (AccelerationConfidence)mComponents[1];
    }
    
    public void setLongitudinalAccelerationConfidence(AccelerationConfidence longitudinalAccelerationConfidence)
    {
	mComponents[1] = longitudinalAccelerationConfidence;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "LongitudinalAcceleration"
	),
	new QName (
	    "ITS-Container",
	    "LongitudinalAcceleration"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				"LongitudinalAccelerationValue"
			    ),
			    new QName (
				"ITS-Container",
				"LongitudinalAccelerationValue"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new LongitudinalAccelerationValue(-160), 
				    new LongitudinalAccelerationValue(161),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-160),
				new java.lang.Long(161)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"pointOneMeterPerSecSquaredForward",
					1
				    ),
				    new MemberListElement (
					"pointOneMeterPerSecSquaredBackward",
					-1
				    ),
				    new MemberListElement (
					"unavailable",
					161
				    )
				}
			    )
			)
		    ),
		    "longitudinalAccelerationValue",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
				"AccelerationConfidence"
			    ),
			    new QName (
				"ITS-Container",
				"AccelerationConfidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new AccelerationConfidence(0), 
				    new AccelerationConfidence(102),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(102)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"pointOneMeterPerSecSquared",
					1
				    ),
				    new MemberListElement (
					"outOfRange",
					101
				    ),
				    new MemberListElement (
					"unavailable",
					102
				    )
				}
			    )
			)
		    ),
		    "longitudinalAccelerationConfidence",
		    1,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' LongitudinalAcceleration object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' LongitudinalAcceleration object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for LongitudinalAcceleration
