/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type TrafficRule from ASN1 Module ITS_Container.
 * @see Enumerated
 */

public final class TrafficRule extends Enumerated {
    
    /**
     * The default constructor.
     */
    private TrafficRule()
    {
	super(cFirstNumber);
    }
    
    protected TrafficRule(long value)
    {
	super(value);
    }
    
    public static final class Value {
	public static final long noPassing = 0;
	public static final long noPassingForTrucks = 1;
	
    }
    // Named list definitions.
    public static final TrafficRule noPassing =
	new TrafficRule();
    public static final TrafficRule noPassingForTrucks =
	new TrafficRule(1);
    private final static TrafficRule cNamedNumbers[] = {
	 noPassing, 
	 noPassingForTrucks
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public Enumerated[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    public static TrafficRule valueOf(long value)
    {
	return (TrafficRule)noPassing.lookupValue(value);
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
	new Tags (
	    new short[] {
		0x000a
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "TrafficRule"
	),
	new QName (
	    "ITS-Container",
	    "TrafficRule"
	),
	12318,
	null,
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "noPassing",
		    0
		),
		new MemberListElement (
		    "noPassingForTrucks",
		    1
		)
	    }
	),
	0,
	noPassing
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' TrafficRule object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' TrafficRule object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Methods for "unknownEnumerator"
     */
    private static final TrafficRule cUnknownEnumerator = 
	new TrafficRule(-1);
    
    public boolean isUnknownEnumerator()
    {
	return this == cUnknownEnumerator;
    }
    
    public Enumerated getUnknownEnumerator()
    {
	return cUnknownEnumerator;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for TrafficRule
