/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type VDS from ASN1 Module ITS_Container.
 * @see IA5String
 */

public class VDS extends IA5String {
    
    /**
     * The default constructor.
     */
    public VDS()
    {
    }
    
    /**
     * Construct from a String type.
     * @param value the String to set this object to.
     */
    public VDS(String value)
    {
	super(value);
    }
    
    
    /**
     * Construct from a char[] type.
     * @param value the char[] to set this object to.
     */
    public VDS(char[] value)
    {
	super(value);
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final KMCStringInfo c_typeinfo = new KMCStringInfo (
	new Tags (
	    new short[] {
		0x0016
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "VDS"
	),
	new QName (
	    "ITS-Container",
	    "VDS"
	),
	12314,
	new Intersection (
	    new SizeConstraint (
		new SingleValueConstraint (
		    new com.oss.asn1.INTEGER(6)
		)
	    ),
	    new PermittedAlphabetConstraint (
		IA5StringPAInfo.pa
	    )
	),
	new Bounds (
	    new java.lang.Long(6),
	    new java.lang.Long(6)
	),
	IA5StringPAInfo.paInfo
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' VDS object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' VDS object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for VDS
