/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: its-container */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.Libitscdd_asn1 */
/* Created: Tue Aug  6 16:01:06 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6815550803953835147gen/LibItsCdd_asn1.gen
 * ITS-Container.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type VehicleRole from ASN1 Module ITS_Container.
 * @see Enumerated
 */

public final class VehicleRole extends Enumerated {
    
    /**
     * The default constructor.
     */
    private VehicleRole()
    {
	super(cFirstNumber);
    }
    
    protected VehicleRole(long value)
    {
	super(value);
    }
    
    public static final class Value {
	public static final long _default = 0;
	public static final long publicTransport = 1;
	public static final long specialTransport = 2;
	public static final long dangerousGoods = 3;
	public static final long roadWork = 4;
	public static final long rescue = 5;
	public static final long emergency = 6;
	public static final long safetyCar = 7;
    }
    // Named list definitions.
    public static final VehicleRole _default =
	new VehicleRole();
    public static final VehicleRole publicTransport =
	new VehicleRole(1);
    public static final VehicleRole specialTransport =
	new VehicleRole(2);
    public static final VehicleRole dangerousGoods =
	new VehicleRole(3);
    public static final VehicleRole roadWork =
	new VehicleRole(4);
    public static final VehicleRole rescue =
	new VehicleRole(5);
    public static final VehicleRole emergency =
	new VehicleRole(6);
    public static final VehicleRole safetyCar =
	new VehicleRole(7);
    private final static VehicleRole cNamedNumbers[] = {
	 _default, 
	 publicTransport, 
	 specialTransport, 
	 dangerousGoods, 
	 roadWork, 
	 rescue, 
	 emergency, 
	 safetyCar
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public Enumerated[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    public static VehicleRole valueOf(long value)
    {
	return (VehicleRole)_default.lookupValue(value);
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
	new Tags (
	    new short[] {
		0x000a
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCdd_asn1.its_container",
	    "VehicleRole"
	),
	new QName (
	    "ITS-Container",
	    "VehicleRole"
	),
	12314,
	null,
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "default",
		    0
		),
		new MemberListElement (
		    "publicTransport",
		    1
		),
		new MemberListElement (
		    "specialTransport",
		    2
		),
		new MemberListElement (
		    "dangerousGoods",
		    3
		),
		new MemberListElement (
		    "roadWork",
		    4
		),
		new MemberListElement (
		    "rescue",
		    5
		),
		new MemberListElement (
		    "emergency",
		    6
		),
		new MemberListElement (
		    "safetyCar",
		    7
		)
	    }
	),
	0,
	_default
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' VehicleRole object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' VehicleRole object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for VehicleRole
