/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1;

import com.oss.asn1.*;
import com.oss.metadata.*;

public class Libitsdenm_asn1 extends ASN1Project {

    /**
     * Initialize the pdu decoder.
     */
    private static final ProjectInfo c_projectInfo = new ProjectInfo (
	null,
	new byte[] {
	    (byte)0x0b, (byte)0x85, (byte)0xbd, (byte)0x97, (byte)0x8f,
	    (byte)0x45, (byte)0x34, (byte)0x06, (byte)0x09, (byte)0x44,
	    (byte)0x34, (byte)0x06, (byte)0x09, (byte)0xe4, (byte)0x51,
	    (byte)0x8f, (byte)0x14, (byte)0xbf, (byte)0x04, (byte)0xb2,
	    (byte)0xc1, (byte)0x09, (byte)0xf4, (byte)0x2c, (byte)0xa0,
	    (byte)0x4c, (byte)0x93, (byte)0xdc, (byte)0x6f, (byte)0xfb,
	    (byte)0x4c, (byte)0xed, (byte)0x1e, (byte)0x26, (byte)0x7a,
	    (byte)0xf8, (byte)0x06, (byte)0x40, (byte)0x9c, (byte)0x31,
	    (byte)0xbc, (byte)0xd5, (byte)0x9a, (byte)0xb8, (byte)0x56,
	    (byte)0xbe, (byte)0x4b, (byte)0xc8, (byte)0x41, (byte)0x3b,
	    (byte)0xf7, (byte)0x7a, (byte)0x0b, (byte)0x3c, (byte)0x57,
	    (byte)0x18, (byte)0xa3, (byte)0xfc, (byte)0xc1, (byte)0x8a,
	    (byte)0x80, (byte)0xce, (byte)0x3b, (byte)0x5e, (byte)0x73,
	    (byte)0x5d, (byte)0xd6, (byte)0x36, (byte)0xf1, (byte)0xd8,
	    (byte)0x87, (byte)0x8a, (byte)0x6e, (byte)0x8d, (byte)0x8e,
	    (byte)0x22, (byte)0x6e, (byte)0x7d, (byte)0xe8, (byte)0x25,
	    (byte)0x8a, (byte)0x2c, (byte)0xb3, (byte)0x5d, (byte)0x35,
	    (byte)0x78, (byte)0x8e, (byte)0xa9, (byte)0x14, (byte)0x94,
	    (byte)0x44, (byte)0x80, (byte)0xba, (byte)0x42, (byte)0xc4,
	    (byte)0x10, (byte)0x5b, (byte)0x6a, (byte)0x3e, (byte)0x65,
	    (byte)0x83, (byte)0xac, (byte)0x69, (byte)0x2a, (byte)0x56,
	    (byte)0x45, (byte)0x12, (byte)0xaa, (byte)0x8c, (byte)0x87,
	    (byte)0xc9, (byte)0x72, (byte)0x5e, (byte)0x36, (byte)0x4e,
	    (byte)0x1e, (byte)0x0b, (byte)0x62, (byte)0x26, (byte)0x77,
	    (byte)0x05, (byte)0x57, (byte)0xe7, (byte)0x89, (byte)0xc5,
	    (byte)0xce
	}
    );
    
    /**
     * Get the project descriptor of 'this' object.
     */
    public ProjectInfo getProjectInfo()
    {
	return c_projectInfo;
    }
    
    private static final ASN1Project c_project = new Libitsdenm_asn1();

    /**
     * Methods for accessing Coders.
     */
    public static Coder getDefaultCoder()
    {
	return createPERAlignedCoder(c_project);
    }
    
    public static PERAlignedCoder getPERAlignedCoder()
    {
	return createPERAlignedCoder(c_project);
    }
    
    public static PERUnalignedCoder getPERUnalignedCoder()
    {
	return createPERUnalignedCoder(c_project);
    }
    
}
