/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type StationaryVehicleContainer from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class StationaryVehicleContainer extends Sequence {
    
    /**
     * The default constructor.
     */
    public StationaryVehicleContainer()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public StationaryVehicleContainer(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType stationType, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationarySince stationarySince, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode stationaryCause, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.DangerousGoodsExtended carryingDangerousGoods, 
		    INTEGER numberOfOccupants, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.VehicleIdentification vehicleIdentification, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.EnergyStorageType energyStorageType)
    {
	setStationType(stationType);
	setStationarySince(stationarySince);
	setStationaryCause(stationaryCause);
	setCarryingDangerousGoods(carryingDangerousGoods);
	setNumberOfOccupants(numberOfOccupants);
	setVehicleIdentification(vehicleIdentification);
	setEnergyStorageType(energyStorageType);
    }
    
    /**
     * Construct with components.
     */
    public StationaryVehicleContainer(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType stationType, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationarySince stationarySince, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode stationaryCause, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.DangerousGoodsExtended carryingDangerousGoods, 
		    long numberOfOccupants, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.VehicleIdentification vehicleIdentification, 
		    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.EnergyStorageType energyStorageType)
    {
	this(stationType, stationarySince, stationaryCause, 
	     carryingDangerousGoods, new INTEGER(numberOfOccupants), 
	     vehicleIdentification, energyStorageType);
    }
    
    /**
     * Construct with required components.
     */
    public StationaryVehicleContainer(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType stationType)
    {
	setStationType(stationType);
    }
    
    public void initComponents()
    {
	mComponents[0] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType();
	mComponents[1] = org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationarySince.lessThan1Minute;
	mComponents[2] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode();
	mComponents[3] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.DangerousGoodsExtended();
	mComponents[4] = new INTEGER();
	mComponents[5] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.VehicleIdentification();
	mComponents[6] = new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.EnergyStorageType();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[7];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType();
	    case 1:
		return org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationarySince.lessThan1Minute;
	    case 2:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode();
	    case 3:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.DangerousGoodsExtended();
	    case 4:
		return new INTEGER();
	    case 5:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.VehicleIdentification();
	    case 6:
		return new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.EnergyStorageType();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "stationType"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType getStationType()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType)mComponents[0];
    }
    
    public void setStationType(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType stationType)
    {
	mComponents[0] = stationType;
    }
    
    
    // Methods for field "stationarySince"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationarySince getStationarySince()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationarySince)mComponents[1];
    }
    
    public void setStationarySince(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationarySince stationarySince)
    {
	mComponents[1] = stationarySince;
    }
    
    public boolean hasStationarySince()
    {
	return componentIsPresent(1);
    }
    
    public void deleteStationarySince()
    {
	setComponentAbsent(1);
    }
    
    
    // Methods for field "stationaryCause"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode getStationaryCause()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode)mComponents[2];
    }
    
    public void setStationaryCause(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.CauseCode stationaryCause)
    {
	mComponents[2] = stationaryCause;
    }
    
    public boolean hasStationaryCause()
    {
	return componentIsPresent(2);
    }
    
    public void deleteStationaryCause()
    {
	setComponentAbsent(2);
    }
    
    
    // Methods for field "carryingDangerousGoods"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.DangerousGoodsExtended getCarryingDangerousGoods()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.DangerousGoodsExtended)mComponents[3];
    }
    
    public void setCarryingDangerousGoods(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.DangerousGoodsExtended carryingDangerousGoods)
    {
	mComponents[3] = carryingDangerousGoods;
    }
    
    public boolean hasCarryingDangerousGoods()
    {
	return componentIsPresent(3);
    }
    
    public void deleteCarryingDangerousGoods()
    {
	setComponentAbsent(3);
    }
    
    
    // Methods for field "numberOfOccupants"
    public long getNumberOfOccupants()
    {
	return ((INTEGER)mComponents[4]).longValue();
    }
    
    public void setNumberOfOccupants(long numberOfOccupants)
    {
	setNumberOfOccupants(new INTEGER(numberOfOccupants));
    }
    
    public void setNumberOfOccupants(INTEGER numberOfOccupants)
    {
	mComponents[4] = numberOfOccupants;
    }
    
    public boolean hasNumberOfOccupants()
    {
	return componentIsPresent(4);
    }
    
    public void deleteNumberOfOccupants()
    {
	setComponentAbsent(4);
    }
    
    
    // Methods for field "vehicleIdentification"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.VehicleIdentification getVehicleIdentification()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.VehicleIdentification)mComponents[5];
    }
    
    public void setVehicleIdentification(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.VehicleIdentification vehicleIdentification)
    {
	mComponents[5] = vehicleIdentification;
    }
    
    public boolean hasVehicleIdentification()
    {
	return componentIsPresent(5);
    }
    
    public void deleteVehicleIdentification()
    {
	setComponentAbsent(5);
    }
    
    
    // Methods for field "energyStorageType"
    public org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.EnergyStorageType getEnergyStorageType()
    {
	return (org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.EnergyStorageType)mComponents[6];
    }
    
    public void setEnergyStorageType(org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.EnergyStorageType energyStorageType)
    {
	mComponents[6] = energyStorageType;
    }
    
    public boolean hasEnergyStorageType()
    {
	return componentIsPresent(6);
    }
    
    public void deleteEnergyStorageType()
    {
	setComponentAbsent(6);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "StationaryVehicleContainer"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "StationaryVehicleContainer"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"StationType"
			    ),
			    new QName (
				"ITS-Container",
				"StationType"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType(0), 
				    new org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationType(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"unknown",
					0
				    ),
				    new MemberListElement (
					"pedestrian",
					1
				    ),
				    new MemberListElement (
					"cyclist",
					2
				    ),
				    new MemberListElement (
					"moped",
					3
				    ),
				    new MemberListElement (
					"motorcycle",
					4
				    ),
				    new MemberListElement (
					"passengerCar",
					5
				    ),
				    new MemberListElement (
					"bus",
					6
				    ),
				    new MemberListElement (
					"lightTruck",
					7
				    ),
				    new MemberListElement (
					"heavyTruck",
					8
				    ),
				    new MemberListElement (
					"trailer",
					9
				    ),
				    new MemberListElement (
					"specialVehicles",
					10
				    ),
				    new MemberListElement (
					"tram",
					11
				    ),
				    new MemberListElement (
					"roadSideUnit",
					15
				    )
				}
			    )
			)
		    ),
		    "stationType",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"StationarySince"
			    ),
			    new QName (
				"ITS-Container",
				"StationarySince"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"lessThan1Minute",
					0
				    ),
				    new MemberListElement (
					"lessThan2Minutes",
					1
				    ),
				    new MemberListElement (
					"lessThan15Minutes",
					2
				    ),
				    new MemberListElement (
					"over15Minutes",
					3
				    )
				}
			    ),
			    0,
			    org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container.StationarySince.lessThan1Minute
			)
		    ),
		    "stationarySince",
		    1,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"CauseCode"
			    ),
			    new QName (
				"ITS-Container",
				"CauseCode"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "CauseCode"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "CauseCode"
				)
			    ),
			    0
			)
		    ),
		    "stationaryCause",
		    2,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"DangerousGoodsExtended"
			    ),
			    new QName (
				"ITS-Container",
				"DangerousGoodsExtended"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "DangerousGoodsExtended"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "DangerousGoodsExtended"
				)
			    ),
			    0
			)
		    ),
		    "carryingDangerousGoods",
		    3,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8004
				}
			    ),
			    new QName (
				"com.oss.asn1",
				"INTEGER"
			    ),
			    new QName (
				"builtin",
				"INTEGER"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new com.oss.asn1.INTEGER(0), 
				    new com.oss.asn1.INTEGER(127),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(127)
			    ),
			    null
			)
		    ),
		    "numberOfOccupants",
		    4,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8005
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"VehicleIdentification"
			    ),
			    new QName (
				"ITS-Container",
				"VehicleIdentification"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "VehicleIdentification"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				    "VehicleIdentification"
				)
			    ),
			    0
			)
		    ),
		    "vehicleIdentification",
		    5,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8006
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"EnergyStorageType"
			    ),
			    new QName (
				"ITS-Container",
				"EnergyStorageType"
			    ),
			    12314,
			    new SizeConstraint (
				new SingleValueConstraint (
				    new com.oss.asn1.INTEGER(7)
				)
			    ),
			    new Bounds (
				new java.lang.Long(7),
				new java.lang.Long(7)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"hydrogenStorage",
					0
				    ),
				    new MemberListElement (
					"electricEnergyStorage",
					1
				    ),
				    new MemberListElement (
					"liquidPropaneGas",
					2
				    ),
				    new MemberListElement (
					"compressedNaturalGas",
					3
				    ),
				    new MemberListElement (
					"diesel",
					4
				    ),
				    new MemberListElement (
					"gasoline",
					5
				    ),
				    new MemberListElement (
					"ammonia",
					6
				    )
				}
			    )
			)
		    ),
		    "energyStorageType",
		    6,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8006, 6)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' StationaryVehicleContainer object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' StationaryVehicleContainer object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for StationaryVehicleContainer
