/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode from ASN1 Module ITS_Container.
 * @see INTEGER
 */

public class AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode extends INTEGER {
    
    /**
     * The default constructor.
     */
    public AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode()
    {
    }
    
    public AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(short value)
    {
	super(value);
    }
    
    public AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(int value)
    {
	super(value);
    }
    
    public AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(long value)
    {
	super(value);
    }
    
    // Named list definitions.
    public static final AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode unavailable =
	new AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(0);
    public static final AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode strongWinds =
	new AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(1);
    public static final AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode damagingHail =
	new AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(2);
    public static final AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode hurricane =
	new AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(3);
    public static final AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode thunderstorm =
	new AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(4);
    public static final AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode tornado =
	new AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(5);
    public static final AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode blizzard =
	new AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(6);
    private final static AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode cNamedNumbers[] = {
	 unavailable, 
	 strongWinds, 
	 damagingHail, 
	 hurricane, 
	 thunderstorm, 
	 tornado, 
	 blizzard
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public INTEGER[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final IntegerInfo c_typeinfo = new IntegerInfo (
	new Tags (
	    new short[] {
		0x0002
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
	    "AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode"
	),
	new QName (
	    "ITS-Container",
	    "AdverseWeatherCondition-ExtremeWeatherConditionSubCauseCode"
	),
	12314,
	new ValueRangeConstraint (
	    new AbstractBounds(
		new AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(0), 
		new AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode(255),
		0
	    )
	),
	new Bounds (
	    new java.lang.Long(0),
	    new java.lang.Long(255)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "unavailable",
		    0
		),
		new MemberListElement (
		    "strongWinds",
		    1
		),
		new MemberListElement (
		    "damagingHail",
		    2
		),
		new MemberListElement (
		    "hurricane",
		    3
		),
		new MemberListElement (
		    "thunderstorm",
		    4
		),
		new MemberListElement (
		    "tornado",
		    5
		),
		new MemberListElement (
		    "blizzard",
		    6
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for AdverseWeatherCondition_ExtremeWeatherConditionSubCauseCode
