/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type CauseCode from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class CauseCode extends Sequence {
    
    /**
     * The default constructor.
     */
    public CauseCode()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public CauseCode(CauseCodeType causeCode, SubCauseCodeType subCauseCode)
    {
	setCauseCode(causeCode);
	setSubCauseCode(subCauseCode);
    }
    
    public void initComponents()
    {
	mComponents[0] = new CauseCodeType();
	mComponents[1] = new SubCauseCodeType();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new CauseCodeType();
	    case 1:
		return new SubCauseCodeType();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "causeCode"
    public CauseCodeType getCauseCode()
    {
	return (CauseCodeType)mComponents[0];
    }
    
    public void setCauseCode(CauseCodeType causeCode)
    {
	mComponents[0] = causeCode;
    }
    
    
    // Methods for field "subCauseCode"
    public SubCauseCodeType getSubCauseCode()
    {
	return (SubCauseCodeType)mComponents[1];
    }
    
    public void setSubCauseCode(SubCauseCodeType subCauseCode)
    {
	mComponents[1] = subCauseCode;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
	    "CauseCode"
	),
	new QName (
	    "ITS-Container",
	    "CauseCode"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"CauseCodeType"
			    ),
			    new QName (
				"ITS-Container",
				"CauseCodeType"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new CauseCodeType(0), 
				    new CauseCodeType(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"reserved",
					0
				    ),
				    new MemberListElement (
					"trafficCondition",
					1
				    ),
				    new MemberListElement (
					"accident",
					2
				    ),
				    new MemberListElement (
					"roadworks",
					3
				    ),
				    new MemberListElement (
					"adverseWeatherCondition-Adhesion",
					6
				    ),
				    new MemberListElement (
					"hazardousLocation-SurfaceCondition",
					9
				    ),
				    new MemberListElement (
					"hazardousLocation-ObstacleOnTheRoad",
					10
				    ),
				    new MemberListElement (
					"hazardousLocation-AnimalOnTheRoad",
					11
				    ),
				    new MemberListElement (
					"humanPresenceOnTheRoad",
					12
				    ),
				    new MemberListElement (
					"wrongWayDriving",
					14
				    ),
				    new MemberListElement (
					"rescueAndRecoveryWorkInProgress",
					15
				    ),
				    new MemberListElement (
					"adverseWeatherCondition-ExtremeWeatherCondition",
					17
				    ),
				    new MemberListElement (
					"adverseWeatherCondition-Visibility",
					18
				    ),
				    new MemberListElement (
					"adverseWeatherCondition-Precipitation",
					19
				    ),
				    new MemberListElement (
					"slowVehicle",
					26
				    ),
				    new MemberListElement (
					"dangerousEndOfQueue",
					27
				    ),
				    new MemberListElement (
					"vehicleBreakdown",
					91
				    ),
				    new MemberListElement (
					"postCrash",
					92
				    ),
				    new MemberListElement (
					"humanProblem",
					93
				    ),
				    new MemberListElement (
					"stationaryVehicle",
					94
				    ),
				    new MemberListElement (
					"emergencyVehicleApproaching",
					95
				    ),
				    new MemberListElement (
					"hazardousLocation-DangerousCurve",
					96
				    ),
				    new MemberListElement (
					"collisionRisk",
					97
				    ),
				    new MemberListElement (
					"signalViolation",
					98
				    ),
				    new MemberListElement (
					"dangerousSituation",
					99
				    )
				}
			    )
			)
		    ),
		    "causeCode",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"SubCauseCodeType"
			    ),
			    new QName (
				"ITS-Container",
				"SubCauseCodeType"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new SubCauseCodeType(0), 
				    new SubCauseCodeType(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    null
			)
		    ),
		    "subCauseCode",
		    1,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' CauseCode object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' CauseCode object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for CauseCode
