/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type ClosedLanes from ASN1 Module ITS_Container.
 * @see Sequence
 */

public class ClosedLanes extends Sequence {
    
    /**
     * The default constructor.
     */
    public ClosedLanes()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public ClosedLanes(HardShoulderStatus hardShoulderStatus, 
		    DrivingLaneStatus drivingLaneStatus)
    {
	setHardShoulderStatus(hardShoulderStatus);
	setDrivingLaneStatus(drivingLaneStatus);
    }
    
    /**
     * Construct with required components.
     */
    public ClosedLanes(DrivingLaneStatus drivingLaneStatus)
    {
	setDrivingLaneStatus(drivingLaneStatus);
    }
    
    public void initComponents()
    {
	mComponents[0] = HardShoulderStatus.availableForStopping;
	mComponents[1] = new DrivingLaneStatus();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[2];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return HardShoulderStatus.availableForStopping;
	    case 1:
		return new DrivingLaneStatus();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "hardShoulderStatus"
    public HardShoulderStatus getHardShoulderStatus()
    {
	return (HardShoulderStatus)mComponents[0];
    }
    
    public void setHardShoulderStatus(HardShoulderStatus hardShoulderStatus)
    {
	mComponents[0] = hardShoulderStatus;
    }
    
    public boolean hasHardShoulderStatus()
    {
	return componentIsPresent(0);
    }
    
    public void deleteHardShoulderStatus()
    {
	setComponentAbsent(0);
    }
    
    
    // Methods for field "drivingLaneStatus"
    public DrivingLaneStatus getDrivingLaneStatus()
    {
	return (DrivingLaneStatus)mComponents[1];
    }
    
    public void setDrivingLaneStatus(DrivingLaneStatus drivingLaneStatus)
    {
	mComponents[1] = drivingLaneStatus;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
	    "ClosedLanes"
	),
	new QName (
	    "ITS-Container",
	    "ClosedLanes"
	),
	12318,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"HardShoulderStatus"
			    ),
			    new QName (
				"ITS-Container",
				"HardShoulderStatus"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"availableForStopping",
					0
				    ),
				    new MemberListElement (
					"closed",
					1
				    ),
				    new MemberListElement (
					"availableForDriving",
					2
				    )
				}
			    ),
			    0,
			    HardShoulderStatus.availableForStopping
			)
		    ),
		    "hardShoulderStatus",
		    0,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
				"DrivingLaneStatus"
			    ),
			    new QName (
				"ITS-Container",
				"DrivingLaneStatus"
			    ),
			    12314,
			    new SizeConstraint (
				new ValueRangeConstraint (
				    new AbstractBounds(
					new com.oss.asn1.INTEGER(1), 
					new com.oss.asn1.INTEGER(14),
					0
				    )
				)
			    ),
			    new Bounds (
				new java.lang.Long(1),
				new java.lang.Long(14)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"outermostLaneClosed",
					1
				    ),
				    new MemberListElement (
					"secondLaneFromOutsideClosed",
					2
				    )
				}
			    )
			)
		    ),
		    "drivingLaneStatus",
		    1,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0),
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' ClosedLanes object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' ClosedLanes object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for ClosedLanes
