/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type HazardousLocation_ObstacleOnTheRoadSubCauseCode from ASN1 Module ITS_Container.
 * @see INTEGER
 */

public class HazardousLocation_ObstacleOnTheRoadSubCauseCode extends INTEGER {
    
    /**
     * The default constructor.
     */
    public HazardousLocation_ObstacleOnTheRoadSubCauseCode()
    {
    }
    
    public HazardousLocation_ObstacleOnTheRoadSubCauseCode(short value)
    {
	super(value);
    }
    
    public HazardousLocation_ObstacleOnTheRoadSubCauseCode(int value)
    {
	super(value);
    }
    
    public HazardousLocation_ObstacleOnTheRoadSubCauseCode(long value)
    {
	super(value);
    }
    
    // Named list definitions.
    public static final HazardousLocation_ObstacleOnTheRoadSubCauseCode unavailable =
	new HazardousLocation_ObstacleOnTheRoadSubCauseCode(0);
    public static final HazardousLocation_ObstacleOnTheRoadSubCauseCode shedLoad =
	new HazardousLocation_ObstacleOnTheRoadSubCauseCode(1);
    public static final HazardousLocation_ObstacleOnTheRoadSubCauseCode partsOfVehicles =
	new HazardousLocation_ObstacleOnTheRoadSubCauseCode(2);
    public static final HazardousLocation_ObstacleOnTheRoadSubCauseCode partsOfTyres =
	new HazardousLocation_ObstacleOnTheRoadSubCauseCode(3);
    public static final HazardousLocation_ObstacleOnTheRoadSubCauseCode bigObjects =
	new HazardousLocation_ObstacleOnTheRoadSubCauseCode(4);
    public static final HazardousLocation_ObstacleOnTheRoadSubCauseCode fallenTrees =
	new HazardousLocation_ObstacleOnTheRoadSubCauseCode(5);
    public static final HazardousLocation_ObstacleOnTheRoadSubCauseCode hubCaps =
	new HazardousLocation_ObstacleOnTheRoadSubCauseCode(6);
    public static final HazardousLocation_ObstacleOnTheRoadSubCauseCode waitingVehicles =
	new HazardousLocation_ObstacleOnTheRoadSubCauseCode(7);
    private final static HazardousLocation_ObstacleOnTheRoadSubCauseCode cNamedNumbers[] = {
	 unavailable, 
	 shedLoad, 
	 partsOfVehicles, 
	 partsOfTyres, 
	 bigObjects, 
	 fallenTrees, 
	 hubCaps, 
	 waitingVehicles
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public INTEGER[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final IntegerInfo c_typeinfo = new IntegerInfo (
	new Tags (
	    new short[] {
		0x0002
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
	    "HazardousLocation_ObstacleOnTheRoadSubCauseCode"
	),
	new QName (
	    "ITS-Container",
	    "HazardousLocation-ObstacleOnTheRoadSubCauseCode"
	),
	12314,
	new ValueRangeConstraint (
	    new AbstractBounds(
		new HazardousLocation_ObstacleOnTheRoadSubCauseCode(0), 
		new HazardousLocation_ObstacleOnTheRoadSubCauseCode(255),
		0
	    )
	),
	new Bounds (
	    new java.lang.Long(0),
	    new java.lang.Long(255)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "unavailable",
		    0
		),
		new MemberListElement (
		    "shedLoad",
		    1
		),
		new MemberListElement (
		    "partsOfVehicles",
		    2
		),
		new MemberListElement (
		    "partsOfTyres",
		    3
		),
		new MemberListElement (
		    "bigObjects",
		    4
		),
		new MemberListElement (
		    "fallenTrees",
		    5
		),
		new MemberListElement (
		    "hubCaps",
		    6
		),
		new MemberListElement (
		    "waitingVehicles",
		    7
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' HazardousLocation_ObstacleOnTheRoadSubCauseCode object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' HazardousLocation_ObstacleOnTheRoadSubCauseCode object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * The type is a PDU.
     */
    public boolean isPDU()
    {
	return true;
    }
    
} // End class definition for HazardousLocation_ObstacleOnTheRoadSubCauseCode
