/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type HeadingValue from ASN1 Module ITS_Container.
 * @see INTEGER
 */

public class HeadingValue extends INTEGER {
    
    /**
     * The default constructor.
     */
    public HeadingValue()
    {
    }
    
    public HeadingValue(short value)
    {
	super(value);
    }
    
    public HeadingValue(int value)
    {
	super(value);
    }
    
    public HeadingValue(long value)
    {
	super(value);
    }
    
    // Named list definitions.
    public static final HeadingValue wgs84North =
	new HeadingValue(0);
    public static final HeadingValue wgs84East =
	new HeadingValue(900);
    public static final HeadingValue wgs84South =
	new HeadingValue(1800);
    public static final HeadingValue wgs84West =
	new HeadingValue(2700);
    public static final HeadingValue unavailable =
	new HeadingValue(3600);
    private final static HeadingValue cNamedNumbers[] = {
	 wgs84North, 
	 wgs84East, 
	 wgs84South, 
	 wgs84West, 
	 unavailable
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public INTEGER[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final IntegerInfo c_typeinfo = new IntegerInfo (
	new Tags (
	    new short[] {
		0x0002
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
	    "HeadingValue"
	),
	new QName (
	    "ITS-Container",
	    "HeadingValue"
	),
	12314,
	new ValueRangeConstraint (
	    new AbstractBounds(
		new HeadingValue(0), 
		new HeadingValue(3600),
		0
	    )
	),
	new Bounds (
	    new java.lang.Long(0),
	    new java.lang.Long(3600)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "wgs84North",
		    0
		),
		new MemberListElement (
		    "wgs84East",
		    900
		),
		new MemberListElement (
		    "wgs84South",
		    1800
		),
		new MemberListElement (
		    "wgs84West",
		    2700
		),
		new MemberListElement (
		    "unavailable",
		    3600
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' HeadingValue object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' HeadingValue object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for HeadingValue
