/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type PositioningSolutionType from ASN1 Module ITS_Container.
 * @see Enumerated
 */

public final class PositioningSolutionType extends Enumerated {
    
    /**
     * The default constructor.
     */
    private PositioningSolutionType()
    {
	super(cFirstNumber);
    }
    
    protected PositioningSolutionType(long value)
    {
	super(value);
    }
    
    public static final class Value {
	public static final long noPositioningSolution = 0;
	public static final long sGNSS = 1;
	public static final long dGNSS = 2;
	public static final long sGNSSplusDR = 3;
	public static final long dGNSSplusDR = 4;
	public static final long dR = 5;
	
    }
    // Named list definitions.
    public static final PositioningSolutionType noPositioningSolution =
	new PositioningSolutionType();
    public static final PositioningSolutionType sGNSS =
	new PositioningSolutionType(1);
    public static final PositioningSolutionType dGNSS =
	new PositioningSolutionType(2);
    public static final PositioningSolutionType sGNSSplusDR =
	new PositioningSolutionType(3);
    public static final PositioningSolutionType dGNSSplusDR =
	new PositioningSolutionType(4);
    public static final PositioningSolutionType dR =
	new PositioningSolutionType(5);
    private final static PositioningSolutionType cNamedNumbers[] = {
	 noPositioningSolution, 
	 sGNSS, 
	 dGNSS, 
	 sGNSSplusDR, 
	 dGNSSplusDR, 
	 dR
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public Enumerated[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    public static PositioningSolutionType valueOf(long value)
    {
	return (PositioningSolutionType)noPositioningSolution.lookupValue(value);
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
	new Tags (
	    new short[] {
		0x000a
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
	    "PositioningSolutionType"
	),
	new QName (
	    "ITS-Container",
	    "PositioningSolutionType"
	),
	12318,
	null,
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "noPositioningSolution",
		    0
		),
		new MemberListElement (
		    "sGNSS",
		    1
		),
		new MemberListElement (
		    "dGNSS",
		    2
		),
		new MemberListElement (
		    "sGNSSplusDR",
		    3
		),
		new MemberListElement (
		    "dGNSSplusDR",
		    4
		),
		new MemberListElement (
		    "dR",
		    5
		)
	    }
	),
	0,
	noPositioningSolution
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' PositioningSolutionType object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' PositioningSolutionType object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Methods for "unknownEnumerator"
     */
    private static final PositioningSolutionType cUnknownEnumerator = 
	new PositioningSolutionType(-1);
    
    public boolean isUnknownEnumerator()
    {
	return this == cUnknownEnumerator;
    }
    
    public Enumerated getUnknownEnumerator()
    {
	return cUnknownEnumerator;
    }
    
} // End class definition for PositioningSolutionType
