/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type VehicleLengthConfidenceIndication from ASN1 Module ITS_Container.
 * @see Enumerated
 */

public final class VehicleLengthConfidenceIndication extends Enumerated {
    
    /**
     * The default constructor.
     */
    private VehicleLengthConfidenceIndication()
    {
	super(cFirstNumber);
    }
    
    protected VehicleLengthConfidenceIndication(long value)
    {
	super(value);
    }
    
    public static final class Value {
	public static final long noTrailerPresent = 0;
	public static final long trailerPresentWithKnownLength = 1;
	public static final long trailerPresentWithUnknownLength = 2;
	public static final long trailerPresenceIsUnknown = 3;
    }
    // Named list definitions.
    public static final VehicleLengthConfidenceIndication noTrailerPresent =
	new VehicleLengthConfidenceIndication();
    public static final VehicleLengthConfidenceIndication trailerPresentWithKnownLength =
	new VehicleLengthConfidenceIndication(1);
    public static final VehicleLengthConfidenceIndication trailerPresentWithUnknownLength =
	new VehicleLengthConfidenceIndication(2);
    public static final VehicleLengthConfidenceIndication trailerPresenceIsUnknown =
	new VehicleLengthConfidenceIndication(3);
    private final static VehicleLengthConfidenceIndication cNamedNumbers[] = {
	 noTrailerPresent, 
	 trailerPresentWithKnownLength, 
	 trailerPresentWithUnknownLength, 
	 trailerPresenceIsUnknown
    };
    protected final static long cFirstNumber = 0;
    protected final static boolean cLinearNumbers = false;
    
    public Enumerated[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    public static VehicleLengthConfidenceIndication valueOf(long value)
    {
	return (VehicleLengthConfidenceIndication)noTrailerPresent.lookupValue(value);
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
	new Tags (
	    new short[] {
		0x000a
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
	    "VehicleLengthConfidenceIndication"
	),
	new QName (
	    "ITS-Container",
	    "VehicleLengthConfidenceIndication"
	),
	12314,
	null,
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "noTrailerPresent",
		    0
		),
		new MemberListElement (
		    "trailerPresentWithKnownLength",
		    1
		),
		new MemberListElement (
		    "trailerPresentWithUnknownLength",
		    2
		),
		new MemberListElement (
		    "trailerPresenceIsUnknown",
		    3
		)
	    }
	),
	0,
	noTrailerPresent
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' VehicleLengthConfidenceIndication object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' VehicleLengthConfidenceIndication object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for VehicleLengthConfidenceIndication
