/*************************************************************/
/* Copyright (C) 2013 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Mon Oct 28 13:55:57 2013 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -per -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6940004722857486805gen/LibItsDenm_asn1.gen
 * ../e11338d5d0d9f934617a264345646bf1/ITS-Container.asn
 * ../e11338d5d0d9f934617a264345646bf1/DENM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type VehicleMass from ASN1 Module ITS_Container.
 * @see INTEGER
 */

public class VehicleMass extends INTEGER {
    
    /**
     * The default constructor.
     */
    public VehicleMass()
    {
    }
    
    public VehicleMass(short value)
    {
	super(value);
    }
    
    public VehicleMass(int value)
    {
	super(value);
    }
    
    public VehicleMass(long value)
    {
	super(value);
    }
    
    // Named list definitions.
    public static final VehicleMass hundredKg =
	new VehicleMass(1);
    public static final VehicleMass unavailable =
	new VehicleMass(1024);
    private final static VehicleMass cNamedNumbers[] = {
	 hundredKg, 
	 unavailable
    };
    protected final static long cFirstNumber = 1;
    protected final static boolean cLinearNumbers = false;
    
    public INTEGER[] getNamedNumbers()
    {
	return cNamedNumbers;
    }
    
    public boolean hasLinearNumbers()
    {
	return cLinearNumbers;
    }
    
    public long getFirstNumber()
    {
	return cFirstNumber;
    }
    
    /**
     * Initialize the type descriptor.
     */
    private static final IntegerInfo c_typeinfo = new IntegerInfo (
	new Tags (
	    new short[] {
		0x0002
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.its_container",
	    "VehicleMass"
	),
	new QName (
	    "ITS-Container",
	    "VehicleMass"
	),
	12314,
	new ValueRangeConstraint (
	    new AbstractBounds(
		new VehicleMass(1), 
		new VehicleMass(1024),
		0
	    )
	),
	new Bounds (
	    new java.lang.Long(1),
	    new java.lang.Long(1024)
	),
	new MemberList (
	    new MemberListElement[] {
		new MemberListElement (
		    "hundredKg",
		    1
		),
		new MemberListElement (
		    "unavailable",
		    1024
		)
	    }
	)
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' VehicleMass object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' VehicleMass object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for VehicleMass
